/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */

/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import moka.lang.System;//Import the class moka.lang.System
import moka.lang.String;//Import the class moka.lang.String

/**
 * Format OpCode I
 *
 * @author  Frdric Brown
 */
public class FormatRR1 extends Format {

	private static FormatRR1 form;

    public String print (ubyte opCode, char *exprP) {
		ubyte I;

		I = DisASM.getByte(exprP, 8);
		exprP += 2;

		String str = new String(DisASM.opVecStr[opCode]);

		str += " ";

		str += ((short)native.I);

		return str;
	}

    public String assemble (ubyte opCode, char *exprP) {
		ubyte I = 0;

		I = DisASM.fetchValue(&exprP);

		String str = DisASM.printHex8(opCode);

		str += DisASM.printHex8(I);

		return str;
	}

	static {
		Format f = FormatRR1.form = new FormatRR1();
		char ** opVecStr = DisASM.opVecStr;
		Format[] opVecForm = DisASM.opVecForm;

		native {
			opVecStr[0x0A] = "SVC";
			opVecForm[0x0A] = f;
		}
	}

	finally {
		FormatRR1.form.finalize();
	}
}