//Defining class EventListener
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * The EventListener interfaces for receiving events.
 * The class that is interested in processing an event
 * implements this interface, and the object created with that
 * class is registered with an other object.  When the event
 * occurs, that object's <code>eventTriggered</code> method is
 * invoked.
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-10-08
 * @since   MDK1.0a
 */
TEventListener * TEventListener0 ( ) {
	TEventListener * this = malloc ( sizeof ( TEventListener ) ) ; 
	this -> class = ( char * ) "EventListener" ; 
	this -> class_id = 30 ; 
	this -> super = ( void * ) Object ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class EventListener
	return this ; 
} 
/**
     * Invoked when an event is triggered.
     *
     * @param sender The object who triggered the event.
     */
