//Defining class FormatRR0
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode R1,R2
 *
 * @author  Frdric Brown
 */
TFormatRR0 * TFormatRR00 ( ) {
	TFormatRR0 * this = malloc ( sizeof ( TFormatRR0 ) ) ; 
	this -> class = ( char * ) "FormatRR0" ; 
	this -> class_id = 2 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatRR0
	this -> print_unsigned_byte_char_p = ( void * ) TFormatRR0_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatRR0_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatRR0_print_unsigned_byte_char_p ( struct FormatRR0 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 ; 
	NYBBLE R2 ; 
	R1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	R2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) R1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) R2 ) ) ; 
	return str ; 
	
} 

TString *  TFormatRR0_assemble_unsigned_byte_char_p ( struct FormatRR0 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 = 0 ; 
	NYBBLE R2 = 0 ; 
	R1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	R2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R2 , 1 ) ) ; 
	return str ; 
	
} 

void FormatRR0_static_ ( ) { 
	TFormat *  f = FormatRR0_form = TFormatRR0_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0x05] = "BALR";
			opVecForm[0x05] = f;

			opVecStr[0x06] = "BCTR";
			opVecForm[0x06] = f;

			opVecStr[0x0D] = "BASR";
			opVecForm[0x0D] = f;

			opVecStr[0x0E] = "MVCL";
			opVecForm[0x0E] = f;

			opVecStr[0x12] = "LTR";
			opVecForm[0x12] = f;

			opVecStr[0x14] = "NR";
			opVecForm[0x14] = f;

			opVecStr[0x15] = "CLR";
			opVecForm[0x15] = f;

			opVecStr[0x16] = "OR";
			opVecForm[0x16] = f;

			opVecStr[0x18] = "LR";
			opVecForm[0x18] = f;

			opVecStr[0x19] = "CR";
			opVecForm[0x19] = f;

			opVecStr[0x1A] = "AR";
			opVecForm[0x1A] = f;

			opVecStr[0x1B] = "SR";
			opVecForm[0x1B] = f;

			opVecStr[0x1C] = "MR";
			opVecForm[0x1C] = f;

			opVecStr[0x1D] = "DR";
			opVecForm[0x1D] = f;
		 
} 

void FormatRR0_finally_ ( ) { 
	FormatRR0_form -> finalize_ ( FormatRR0_form ) ; 
	
} 
/* Instanciates a new FormatRR0. */
TFormatRR0 * TFormatRR0_ ( ) {
	TFormatRR0 * this = TFormatRR00 ( ) ; 
	FormatRR0__ ( this ) ; 
	return this ; 
} 
void FormatRR0__ ( struct FormatRR0 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
