//Defining class FormatRS0
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode R1,R3,D2(B2)
 *
 * @author  Frdric Brown
 */
TFormatRS0 * TFormatRS00 ( ) {
	TFormatRS0 * this = malloc ( sizeof ( TFormatRS0 ) ) ; 
	this -> class = ( char * ) "FormatRS0" ; 
	this -> class_id = 4 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatRS0
	this -> print_unsigned_byte_char_p = ( void * ) TFormatRS0_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatRS0_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatRS0_print_unsigned_byte_char_p ( struct FormatRS0 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 ; 
	NYBBLE R3 ; 
	BITS12 D2 ; 
	NYBBLE B2 ; 
	R1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	R3 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	B2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D2 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) R1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) R3 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")" ) ) ; 
	return str ; 
	
} 

TString *  TFormatRS0_assemble_unsigned_byte_char_p ( struct FormatRS0 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 = 0 ; 
	NYBBLE R3 = 0 ; 
	BITS12 D2 = 0 ; 
	NYBBLE B2 = 0 ; 
	R1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	R3 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	D2 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	B2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R3 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D2 ) ) ; 
	return str ; 
	
} 

void FormatRS0_static_ ( ) { 
	TFormat *  f = FormatRS0_form = TFormatRS0_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0x5D] = "D";
			opVecForm[0x5D] = f;

			opVecStr[0x86] = "BXH";
			opVecForm[0x86] = f;

			opVecStr[0x87] = "BXLE";
			opVecForm[0x87] = f;

			opVecStr[0x90] = "STM";
			opVecForm[0x90] = f;

			opVecStr[0x98] = "LM";
			opVecForm[0x98] = f;
		 
} 

void FormatRS0_finally_ ( ) { 
	FormatRS0_form -> finalize_ ( FormatRS0_form ) ; 
	
} 
/* Instanciates a new FormatRS0. */
TFormatRS0 * TFormatRS0_ ( ) {
	TFormatRS0 * this = TFormatRS00 ( ) ; 
	FormatRS0__ ( this ) ; 
	return this ; 
} 
void FormatRS0__ ( struct FormatRS0 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
