//Defining class FormatRS1
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode R1,D2(B2)
 *
 * @author  Frdric Brown
 */
TFormatRS1 * TFormatRS10 ( ) {
	TFormatRS1 * this = malloc ( sizeof ( TFormatRS1 ) ) ; 
	this -> class = ( char * ) "FormatRS1" ; 
	this -> class_id = 5 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatRS1
	this -> print_unsigned_byte_char_p = ( void * ) TFormatRS1_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatRS1_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatRS1_print_unsigned_byte_char_p ( struct FormatRS1 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 ; 
	BITS12 D2 ; 
	NYBBLE B2 ; 
	R1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	exprP ++ ; 
	B2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D2 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) R1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")" ) ) ; 
	return str ; 
	
} 

TString *  TFormatRS1_assemble_unsigned_byte_char_p ( struct FormatRS1 * this , unsigned byte opCode , char * exprP ) { 
	NYBBLE R1 = 0 ; 
	NYBBLE R3 = 0 ; 
	BITS12 D2 = 0 ; 
	NYBBLE B2 = 0 ; 
	R1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	D2 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	B2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) R3 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D2 ) ) ; 
	return str ; 
	
} 

void FormatRS1_static_ ( ) { 
	TFormat *  f = FormatRS1_form = TFormatRS1_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0x88] = "SRL";
			opVecForm[0x88] = f;

			opVecStr[0x89] = "SLL";
			opVecForm[0x89] = f;
		 
} 

void FormatRS1_finally_ ( ) { 
	FormatRS1_form -> finalize_ ( FormatRS1_form ) ; 
	
} 
/* Instanciates a new FormatRS1. */
TFormatRS1 * TFormatRS1_ ( ) {
	TFormatRS1 * this = TFormatRS10 ( ) ; 
	FormatRS1__ ( this ) ; 
	return this ; 
} 
void FormatRS1__ ( struct FormatRS1 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
