//Defining class FormatSI0
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode D1(B1),I2
 *
 * @author  Frdric Brown
 */
TFormatSI0 * TFormatSI00 ( ) {
	TFormatSI0 * this = malloc ( sizeof ( TFormatSI0 ) ) ; 
	this -> class = ( char * ) "FormatSI0" ; 
	this -> class_id = 8 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatSI0
	this -> print_unsigned_byte_char_p = ( void * ) TFormatSI0_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatSI0_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatSI0_print_unsigned_byte_char_p ( struct FormatSI0 * this , unsigned byte opCode , char * exprP ) { 
	BITS12 D1 ; 
	NYBBLE B1 ; 
	unsigned byte I2 ; 
	I2 = DisASM_getByte_char_p_short_int ( exprP , 8 ) ; 
	exprP += 2 ; 
	B1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D1 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "),X'" ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte ( I2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "'" ) ) ; 
	return str ; 
	
} 

TString *  TFormatSI0_assemble_unsigned_byte_char_p ( struct FormatSI0 * this , unsigned byte opCode , char * exprP ) { 
	unsigned byte I2 = 0 ; 
	BITS12 D1 = 0 ; 
	NYBBLE B1 = 0 ; 
	D1 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	B1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	I2 = DisASM_fetchValue_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte ( I2 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( B1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D1 ) ) ; 
	return str ; 
	
} 

void FormatSI0_static_ ( ) { 
	TFormat *  f = FormatSI0_form = TFormatSI0_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0x91] = "TM";
			opVecForm[0x91] = f;

			opVecStr[0x92] = "MVI";
			opVecForm[0x92] = f;

			opVecStr[0x94] = "NI";
			opVecForm[0x94] = f;

			opVecStr[0x95] = "CLI";
			opVecForm[0x95] = f;

			opVecStr[0x96] = "OI";
			opVecForm[0x96] = f;

			opVecStr[0x97] = "XI";
			opVecForm[0x97] = f;
		 
} 

void FormatSI0_finally_ ( ) { 
	FormatSI0_form -> finalize_ ( FormatSI0_form ) ; 
	
} 
/* Instanciates a new FormatSI0. */
TFormatSI0 * TFormatSI0_ ( ) {
	TFormatSI0 * this = TFormatSI00 ( ) ; 
	FormatSI0__ ( this ) ; 
	return this ; 
} 
void FormatSI0__ ( struct FormatSI0 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
