//Defining class FormatSS0
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
/**
 * Format OpCode D1(L,B1),D2(B2)
 *
 * @author  Frdric Brown
 */
TFormatSS0 * TFormatSS00 ( ) {
	TFormatSS0 * this = malloc ( sizeof ( TFormatSS0 ) ) ; 
	this -> class = ( char * ) "FormatSS0" ; 
	this -> class_id = 9 ; 
	this -> super = ( void * ) Format ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	//Methods from class Format
	//Methods from class FormatSS0
	this -> print_unsigned_byte_char_p = ( void * ) TFormatSS0_print_unsigned_byte_char_p ; 
	this -> assemble_unsigned_byte_char_p = ( void * ) TFormatSS0_assemble_unsigned_byte_char_p ; 
	return this ; 
} 

TString *  TFormatSS0_print_unsigned_byte_char_p ( struct FormatSS0 * this , unsigned byte opCode , char * exprP ) { 
	BITS12 D1 ; 
	BYTE L ; 
	NYBBLE B1 ; 
	BITS12 D2 ; 
	NYBBLE B2 ; 
	L = DisASM_getByte_char_p_short_int ( exprP , 8 ) ; 
	exprP += 2 ; 
	B1 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D1 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	B2 = DisASM_getByte_char_p_short_int ( exprP ++ , 4 ) ; 
	D2 = DisASM_getHalf_char_p_short_int ( exprP , 12 ) ; 
	exprP += 3 ; 
	TString *  str = TString_char_p ( DisASM_opVecStr [ opCode ] ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) " " ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) ++ L ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B1 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")," ) ) ; 
	str -> append_short_int ( str , ( ( short int ) D2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) "(" ) ) ; 
	str -> append_short_int ( str , ( ( short int ) B2 ) ) ; 
	str -> append_String ( str , TString_char_p ( ( char * ) ")" ) ) ; 
	return str ; 
	
} 

TString *  TFormatSS0_assemble_unsigned_byte_char_p ( struct FormatSS0 * this , unsigned byte opCode , char * exprP ) { 
	BITS12 D1 ; 
	unsigned byte L ; 
	NYBBLE B1 ; 
	BITS12 D2 ; 
	NYBBLE B2 ; 
	D1 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	L = ( BYTE ) DisASM_fetchL_void_p_p ( & exprP ) ; 
	B1 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	D2 = DisASM_fetchD_void_p_p ( & exprP ) ; 
	B2 = DisASM_fetchRegister_void_p_p ( & exprP ) ; 
	TString *  str = DisASM_printHex8_unsigned_byte ( opCode ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte ( -- L ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B1 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D1 ) ) ; 
	str -> append_String ( str , DisASM_printHex8_unsigned_byte_short_int ( ( unsigned byte ) B2 , 1 ) ) ; 
	str -> append_String ( str , DisASM_printHex12_short_int ( ( short int ) D2 ) ) ; 
	return str ; 
	
} 

void FormatSS0_static_ ( ) { 
	TFormat *  f = FormatSS0_form = TFormatSS0_ ( ) ; 
	char * * opVecStr = DisASM_opVecStr ; 
	TFormat *  * opVecForm = DisASM_opVecForm ; 
	opVecStr[0xD2] = "MVC";
			opVecForm[0xD2] = f;

			opVecStr[0xD4] = "NC";
			opVecForm[0xD4] = f;

			opVecStr[0xD5] = "CLC";
			opVecForm[0xD5] = f;

			opVecStr[0xD6] = "OC";
			opVecForm[0xD6] = f;

			opVecStr[0xD7] = "XC";
			opVecForm[0xD7] = f;

			opVecStr[0xDC] = "TR";
			opVecForm[0xDC] = f;

			opVecStr[0xDD] = "TRT";
			opVecForm[0xDD] = f;
		 
} 

void FormatSS0_finally_ ( ) { 
	FormatSS0_form -> finalize_ ( FormatSS0_form ) ; 
	
} 
/* Instanciates a new FormatSS0. */
TFormatSS0 * TFormatSS0_ ( ) {
	TFormatSS0 * this = TFormatSS00 ( ) ; 
	FormatSS0__ ( this ) ; 
	return this ; 
} 
void FormatSS0__ ( struct FormatSS0 * this ) { 
	Format__ ( ( TFormat * ) this ) ; 
} 
