//Defining class Interrupt
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * The Interrupt interfaces for executing code while a thread is running.
 *
 * @author  Frdric Brown
 * @version 1.1, 2002-11-03
 * @since   MDK1.0a
 */
TInterrupt * TInterrupt0 ( ) {
	TInterrupt * this = malloc ( sizeof ( TInterrupt ) ) ; 
	this -> class = ( char * ) "Interrupt" ; 
	this -> class_id = 31 ; 
	this -> super = ( void * ) Object ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class Interrupt
	this -> finalize_ = ( void * ) TInterrupt_finalize_ ; 
	return this ; 
} 

void Interrupt_static_ ( ) { 
	Interrupt_size = 0 ; 
	Interrupt_index = - 1 ; 
	Interrupt_capacity = 5 ; 
	Interrupt_array = malloc ( 5 * sizeof(TInterrupt*) ) ; 
	SetIntVec ( AUTO_INT_5, Interrupt_int5Handler ) ; 
	
} 

void Interrupt_finally_ ( ) { 
	free ( Interrupt_array ) ; 
	SetIntVec ( AUTO_INT_5, Interrupt_oldInt5Handler ) ; 
	
} 
/**
	 * Unregisters the specified interrupt.
	 *
	 * @param item the interrupt to be unregistered.
	 * @since MDK2.1
	 */
void Interrupt_unregister_Interrupt ( struct Interrupt * item ) { 
if (item->registered) {
			item->registered = FALSE;
			Interrupt_busy = TRUE;

	    	long int i;

	    	for (i = 0; i < Interrupt_size; i++) {
	    		if (Interrupt_array[i] == item) {
	    			break;
	    		}
	    	}

	   		memmove(Interrupt_array + i, Interrupt_array + i + 1, (Interrupt_size - i - 1) * sizeof(TInterrupt*));
	   		Interrupt_size--;
	   		if (Interrupt_index == Interrupt_size) {
	   			Interrupt_index == 0;
	   		}

	   		if (Interrupt_size < 1) {
	   			Interrupt_index = -1;
	   		}

	   		Interrupt_busy = FALSE;
	   	}
	
} 
/**
     * Frees the ressources used by this Interrupt.
     *
     * @since MDK2.1
     */
void TInterrupt_finalize_ ( struct Interrupt * this ) { 
	if ( this -> registered ) { 
		Interrupt_unregister_Interrupt ( this ) ; 
		
	} 
	free ( this ) ; 
	
} 
/**
	 * Used by a thread to verify if this interrupt should be executed.
	 *
	 * @return true if this interrupt should be executed
	 */
/**
	 * Handles the code to execute when this object interrupts.
	 */
