//Defining class MenuItem
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2003 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * MenuItem class represents an item of a menu.
 * All items in a menu must belong to the class MenuItem, or one of its subclasses.
 *
 * @author  Frdric Brown
 * @version 1.0, 2003-10-12
 * @since   MDK2.1
 */
TMenuItem * TMenuItem0 ( ) {
	TMenuItem * this = malloc ( sizeof ( TMenuItem ) ) ; 
	this -> class = ( char * ) "MenuItem" ; 
	this -> class_id = 27 ; 
	this -> super = ( void * ) EventListener ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class MenuItem
	this -> setCaption_String = ( void * ) TMenuItem_setCaption_String ; 
	this -> finalize_ = ( void * ) TMenuItem_finalize_ ; 
	return this ; 
} 
/*
	 * Constructs a new MenuItem specifying its caption.
	 *
	 * @param caption the MenuItem's caption.
	 */
TMenuItem * TMenuItem_String ( struct String * caption ) {
	TMenuItem * this = TMenuItem0 ( ) ; 
	MenuItem__String ( this , caption ) ; 
	return this ; 
} 
void MenuItem__String ( struct MenuItem * this , struct String * caption ) { 
	this -> caption = caption ; 
	//this.menu = null; 
	this -> listen = NULL ; 
	this -> mnemonic = 0 ; 
	
} 
/**
 	 * Sets the caption of the MenuItem.
 	 *
 	 * @param caption The caption of the MenuItem.
 	 */
void TMenuItem_setCaption_String ( struct MenuItem * this , struct String * caption ) { 
	this -> caption -> finalize_ ( this -> caption ) ; 
	this -> caption = caption ; 
	
} 
/**
	 * Frees the memory of system ressources used by this MenuItem
	 * object.
	 */
void TMenuItem_finalize_ ( struct MenuItem * this ) { 
	this -> caption -> finalize_ ( this -> caption ) ; 
	EventListener -> finalize_ ( this ) ; 
	
} 
