//Defining class TextField
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * TextField class is a text entry component.
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-11-04
 * @since   MDK1.0a
 */
TTextField * TTextField0 ( ) {
	TTextField * this = malloc ( sizeof ( TTextField ) ) ; 
	this -> class = ( char * ) "TextField" ; 
	this -> class_id = 25 ; 
	this -> super = ( void * ) CaptionedComponent ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> onPaint_ = ( void * ) TComponent_onPaint_ ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> setVisible_BOOL = ( void * ) TComponent_setVisible_BOOL ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TComponent_isCursorOver_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	this -> toFront_Component = ( void * ) TComponent_toFront_Component ; 
	this -> clean_ = ( void * ) TComponent_clean_ ; 
	this -> checkMnemonic_char = ( void * ) TComponent_checkMnemonic_char ; 
	//Methods from class CaptionedComponent
	this -> finalize_ = ( void * ) TCaptionedComponent_finalize_ ; 
	this -> setCaption_String = ( void * ) TCaptionedComponent_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TCaptionedComponent_setFont_short_int ; 
	//Methods from class TextField
	this -> paint_ = ( void * ) TTextField_paint_ ; 
	this -> use_ = ( void * ) TTextField_use_ ; 
	this -> checkInput_short_int_char_p_short_int = ( void * ) TTextField_checkInput_short_int_char_p_short_int ; 
	return this ; 
} 
/*
	 * Constructs a new TextField.
	 */
TTextField * TTextField_ ( ) {
	TTextField * this = TTextField0 ( ) ; 
	TextField__ ( this ) ; 
	return this ; 
} 
void TextField__ ( struct TextField * this ) { 
	TextField__String ( this , TString_char_p ( ( char * ) "" ) ) ; 
	
} 
/*
	 * Constructs a new TextField specifying its caption.
	 *
	 * @param caption the TextField's caption.
	 */
TTextField * TTextField_String ( struct String * caption ) {
	TTextField * this = TTextField0 ( ) ; 
	TextField__String ( this , caption ) ; 
	return this ; 
} 
void TextField__String ( struct TextField * this , struct String * caption ) { 
	CaptionedComponent__String ( ( TCaptionedComponent *  ) this , caption ) ; 
	this -> maxLength = 255 ; 
	this -> inputType = TextField_NO_INPUT_TYPE ; 
	this -> mask = 0 ; 
	
} 
/**
	 * Paints the textfield.
	 */
void TTextField_paint_ ( struct TextField * this ) { 
/*int x1 = this->width - 1;
		int y1 = this->height - 1;

		DrawLine(0, 0, x1, 0, A_NORMAL);
		DrawLine(0, y1, x1, y1, A_NORMAL);
		DrawLine(0, 1, 0, (y1-1), A_NORMAL);
		DrawLine(x1, 1, x1, (y1-1), A_NORMAL);*/

		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(this->font);
		}

		if (this->mask) {
			short len = strlen(this->caption->value);
			char buffer[len + 1];
			memset(buffer, this->mask, len);
			buffer[len] = '\0';
			DrawStr(2, 2, buffer, A_NORMAL);
		}
		else {
			DrawStr(2, 2, this->caption->value, A_NORMAL);
		}

		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(GEM_gem->systemFont);
		}

		DrawClipRect (&(WIN_RECT){0, 0,  this->width - 1, this->height - 1}, GEM_vScrRect, A_NORMAL);
	
} 
/**
	 * This method is invoked by the GEM when the user interacts
	 * with the TextField.
	 */
void TTextField_use_ ( struct TextField * this ) { 
	char buffer [ this -> maxLength + 1 ] ; 
	char mBuffer [ this -> maxLength + 1 ] ; 
	short int ind = 0 ; 
	short int key ; 
	short int x = 0 ; 
	short int y = 0 ; 
	short int max = this -> width / GEM_getFontWidth_short_int ( this -> font ) ; 
	TContainer *  ct = this -> parent ; 
	if ( ! this -> enabled ) { 
		return ; 
		
	} 
	while ( ct ) { 
		x = x + ct -> x ; 
		y = y + ct -> y ; 
		ct = ct -> parent ; 
		
	} 
	x = this -> x + x + 2 ; 
	y = this -> y + y + 2 ; 
	if ( this -> font != Font_FONT_SYSTEM ) { 
		FontSetSys(this->font);
			 
	} 
	if (strlen(this->caption->value) > this->maxLength) {
				this->setCaption_String(this, this->caption->substring_long_int_long_int(this, 0, this->maxLength));
			}
			strcpy(buffer, this->caption->value);
			ind = strlen(buffer);
			if (ind < max) {
				MoveTo(x, y);
				if (this->mask) {
					mBuffer[strlen(buffer)] = '\0';
					printf(memset(mBuffer, this->mask, strlen(buffer)));
				}
				else {
					printf(buffer);
				}
			}
		 while ( TRUE ) { 
		//key = ngetchx(); 
		key = ( GKeyIn(NULL, 0)  ) ; 
		if ( key != KEY_ENTER ) { 
			switch ( key ) { 
				case KEY_BACKSPACE : { 
					//if i != 0, decrement ind 
					if ( ind ) { 
						buffer [ ind ] = '\0' ; 
						buffer [ -- ind ] = ' ' ; 
						
					} 
					break ; 
					
				} 
				case KEY_CLEAR : { 
					/*if (ind >= max) {
	    						ind = max - 1;
	    					}
	
	    					native {
	    						memset(buffer, ' ', ind);
	    					}
	    					buffer[ind] = '\0';*/ 
					ScrRectFill(&(SCR_RECT){{x, y, x + this->width - 4, y + this->height - 4}}, &(SCR_RECT){{x-this->x-2, y-this->y-2, x-this->x+this->parent->width-3, y-this->y+this->parent->height-3}}, A_REVERSE);
	    					 ind = 0 ; 
					buffer [ ind ] = '\0' ; 
					break ; 
					
				} 
				default : { 
					if ( ind >= this -> maxLength || ! this -> checkInput_short_int_char_p_short_int ( this , key , ( char * ) buffer , ind ) ) { 
						break ; 
						
					} 
					ind ++ ; 
					/*buffer[ind++] = key;
		    				buffer[ind] = '\0';*/ 
					
				} 
				
			} 
			if (ind < max) {
							MoveTo(x, y);
							if (this->mask) {
								mBuffer[strlen(buffer)] = '\0';
								memset(&mBuffer[ind], ' ', strlen(buffer) - ind);
								printf(memset(mBuffer, this->mask, ind));
							}
							else {
								printf(buffer);
							}
	
						}
					 buffer [ ind ] = '\0' ; 
			
		} 
		else { 
			break ; 
			
		} 
		
	} 
	if ( this -> font != Font_FONT_SYSTEM ) { 
		FontSetSys(GEM_gem->systemFont);
				 
	} 
	this -> setCaption_String ( this , TString_char_p_BOOL ( Character_copyValueOf_char_p ( ( char * ) buffer ) , FALSE ) ) ; 
	CaptionedComponent -> use_ ( this ) ; 
	
} 
/**
     * Checks if the specified key is a valid input for the
     * input type of this TextField.
     *
     * @param key The key to verify.
     * @return true if the specified key is a valid input, false otherwize.
     */
BOOL TTextField_checkInput_short_int_char_p_short_int ( struct TextField * this , short int key , char * buffer , short int ind ) { 
	TString *  str ; 
	BOOL result = TRUE ; 
	if ( key < 13 && key > 255 ) { 
		return FALSE ; 
		
	} 
	buffer [ ind ] = key ; 
	buffer [ ind + 1 ] = '\0' ; 
	str = TString_char_p ( buffer ) ; 
	switch ( this -> inputType ) { 
		case TextField_INT_INPUT_TYPE : { 
			result = Long_isLong_String ( str ) ; 
			break ; 
			
		} 
		case TextField_FLOAT_INPUT_TYPE : { 
			result = Double_isDouble_String ( str ) ; 
			break ; 
			
		} 
		case TextField_CHAR_INPUT_TYPE : { 
			result = Character_isLetter_char ( ( char ) key ) ; 
			break ; 
			
		} 
		
	} 
	if ( ! result ) { 
		buffer [ ind ] = '\0' ; 
		
	} 
	str -> finalize_ ( str ) ; 
	return result ; 
	
} 
