//Defining class Button
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Button class is a push button component.
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-11-04
 * @since   MDK1.0a
 */
TButton * TButton0 ( ) {
	TButton * this = malloc ( sizeof ( TButton ) ) ; 
	this -> class = ( char * ) "Button" ; 
	this -> class_id = 17 ; 
	this -> super = ( void * ) CaptionedComponent ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> onPaint_ = ( void * ) TComponent_onPaint_ ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> setVisible_BOOL = ( void * ) TComponent_setVisible_BOOL ; 
	this -> use_ = ( void * ) TComponent_use_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TComponent_isCursorOver_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	this -> toFront_Component = ( void * ) TComponent_toFront_Component ; 
	this -> clean_ = ( void * ) TComponent_clean_ ; 
	this -> checkMnemonic_char = ( void * ) TComponent_checkMnemonic_char ; 
	//Methods from class CaptionedComponent
	this -> finalize_ = ( void * ) TCaptionedComponent_finalize_ ; 
	this -> setCaption_String = ( void * ) TCaptionedComponent_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TCaptionedComponent_setFont_short_int ; 
	//Methods from class Button
	this -> paint_ = ( void * ) TButton_paint_ ; 
	return this ; 
} 
/*
	 * Constructs a new button specifying its caption.
	 *
	 * @param caption the button's caption.
	 */
TButton * TButton_String ( struct String * caption ) {
	TButton * this = TButton0 ( ) ; 
	Button__String ( this , caption ) ; 
	return this ; 
} 
void Button__String ( struct Button * this , struct String * caption ) { 
	CaptionedComponent__String ( ( TCaptionedComponent *  ) this , caption ) ; 
	this -> style = Style_RAISED_STYLE ; 
	
} 
/**
	 * Paints the button.
	 */
void TButton_paint_ ( struct Button * this ) { 
int h;
		int w;
		int x1 = this->width - 1;
		int y1 = this->height - 1;
		short style = this->style;
		long int pos;
		long int len = strlen(this->caption->value);
		void* begin = this->caption->value;
		void* end = memchr(begin, this->mnemonic, len);
		
		if (!end) {
			end = memchr(begin, Character_toLowerCase_char(this->mnemonic), len);
		}
		
		if (style == Style_RAISED_STYLE) {
			style = Style_NORMAL_STYLE;
			DrawLine(1, (y1-1), (x1-1), (y1-1), A_NORMAL);
			DrawLine((x1-1), (y1-2), (x1-1), 1, A_NORMAL);
		}
		
		DrawClipRect (&(WIN_RECT){0, 0,  x1, y1}, GEM_vScrRect, A_NORMAL | style);
		/*DrawLine(0, 0, x1, 0, A_NORMAL);
		DrawLine(0, y1, x1, y1, A_NORMAL);
		DrawLine(0, 1, 0, (y1-1), A_NORMAL);
		DrawLine(x1, 1, x1, (y1-1), A_NORMAL);*/
		
		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(this->font);
		}
		
		DrawStr(2, 2, this->caption->value, A_NORMAL);
		
		
		if (end && this->enabled) {
			h = GEM_getFontHeight_short_int(this->font);
			w = GEM_getFontWidth_short_int(this->font);
			
			pos = (long int)((char*)end - (char*)begin);
			
			DrawLine(2 + w * pos, 3 + h , 2 + w * (pos + 1), 3 + h, A_NORMAL);
		}
		
		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(GEM_gem->systemFont);
		}
	
} 
