//Defining class DisASM
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Assembly Studio for MVS
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Assembly Studio for MVS.
 *
 *  Assembly Studio for MVS is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Assembly Studio for MVS is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with Assembly Studio for MVS; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
//Import the class moka.lang.System
//Import the class moka.lang.String
//Import the class moka.lang.Character
//Import the class moka.lang.Integer
/**
 * Some static functions used by the other classes.
 *
 * @author  Frdric Brown
 */

void DisASM_static_ ( ) { 
	DisASM_opVecStr = malloc ( 256 * sizeof(char*) ) ; 
	memset ( DisASM_opVecStr, 0, 256 ) ; 
	DisASM_opVecForm = System_malloc_long_int ( sizeof ( TFormat *  ) * ( 256 ) ) ; 
	memset ( DisASM_opVecForm, 0, 256 ) ; 
	
} 

void DisASM_finally_ ( ) { 
	free ( DisASM_opVecStr ) ; 
	free ( DisASM_opVecForm ) ; 
	
} 

short int DisASM_trouverIndex_char_p ( char * str ) { 
	{ 
		short int i ; 
		for ( i = 0 ; 
		i < DisASM_TAILLE_TABLEAUX ; 
		i ++ ) { 
			if ( ! strcmp ( DisASM_opVecStr[i], str ) ) { 
				return i ; 
				
			} 
			
		} 
		
	} 
	return - 1 ; 
	
} 

TString *  DisASM_printHex12_short_int ( short int s ) { 
char buf[4] = "   ";
		short i = 3;


		while (--i >= 0) {
			if ((s & 0x0F) <= 9) {
				buf[i] = (short) (s & 0x0F) + '0';
			}
			else {
				buf[i] = (short) (s & 0x0F) - 10 + 'A';
			}

			s = s >> 4;
		}

		return TString_char_p_BOOL(Character_copyValueOf_char_p(buf), FALSE);
	
} 

long int DisASM_numValue_char_p ( char * str ) { 
	long int value ; 
	char bufH [ 3 ] ; 
	char bufB [ 9 ] ; 
	short int i ; 
	if ( str [ 0 ] == 'B' ) { 
		str ++ ; 
		if ( str [ 0 ] ) str ++ ; 
		for ( i = 0 ; 
		( str [ 0 ] && ( str [ 0 ] != '\'' && str [ 0 ] != '\"' ) ) && ( i < 8 ) ; 
		i ++ ) { 
			bufB [ i ] = str [ i ] ; 
			
		} 
		bufB [ i ] = '\0' ; 
		value = DisASM_getBin_char_p ( ( char * ) bufB ) ; 
		
	} 
	else if ( str [ 0 ] == 'X' ) { 
		str ++ ; 
		if ( str [ 0 ] ) str ++ ; 
		for ( i = 0 ; 
		( str [ 0 ] && ( str [ 0 ] != '\'' && str [ 0 ] != '\"' ) ) && ( i < 2 ) ; 
		i ++ ) { 
			bufH [ i ] = str [ i ] ; 
			
		} 
		bufH [ i ] = '\0' ; 
		value = DisASM_getByte_char_p_short_int ( ( char * ) bufH , 8 ) ; 
		
	} 
	else { 
		value = Integer_parseInt_String ( TString_char_p ( str ) ) ; 
		
	} 
	return value ; 
	
} 

unsigned byte DisASM_fetchRegister_void_p_p ( void * * strP ) { 
	char * str = * strP ; 
	char buf [ 25 ] ; 
	short int i ; 
	while ( str [ 0 ] == ' ' ) str ++ ; 
	for ( i = 0 ; 
	str [ 0 ] && str [ 0 ] != ' ' && str [ 0 ] != '\n' && str [ 0 ] != ',' && str [ 0 ] != ')' ; 
	i ++ ) { 
		buf [ i ] = * str ++ ; 
		
	} 
	buf [ i ] = '\0' ; 
	while ( str [ 0 ] == ' ' ) str ++ ; 
	if ( str [ 0 ] == ')' ) { 
		str ++ ; 
		
	} 
	while ( str [ 0 ] == ' ' ) str ++ ; 
	if ( str [ 0 ] == ',' || str [ 0 ] == '(' ) { 
		str ++ ; 
		
	} 
	* strP = str ; 
	return DisASM_numValue_char_p ( buf ) ; 
	
} 

unsigned byte DisASM_fetchValue_void_p_p ( void * * strP ) { 
	char * str = * strP ; 
	char buf [ 25 ] ; 
	short int i ; 
	//native.printf("%c", str[0]); native.ngetchx(); 
	while ( str [ 0 ] == ' ' ) str ++ ; 
	if ( str [ 0 ] == ',' ) { 
		str ++ ; 
		while ( str [ 0 ] == ' ' ) str ++ ; 
		
	} 
	for ( i = 0 ; 
	str [ 0 ] && str [ 0 ] != ' ' && str [ 0 ] != '\n' && str [ 0 ] != ',' && str [ 0 ] != ')' ; 
	i ++ ) { 
		buf [ i ] = * str ++ ; 
		
	} 
	buf [ i ] = '\0' ; 
	while ( str [ 0 ] == ' ' ) str ++ ; 
	if ( str [ 0 ] == ',' || str [ 0 ] == '(' ) { 
		str ++ ; 
		
	} 
	* strP = str ; 
	return DisASM_numValue_char_p ( buf ) ; 
	
} 

unsigned short int DisASM_fetchD_void_p_p ( void * * strP ) { 
	char * str = * strP ; 
	char buf [ 25 ] ; 
	short int i ; 
	while ( str [ 0 ] == ' ' || str [ 0 ] == ',' || str [ 0 ] == '(' || str [ 0 ] == ')' ) str ++ ; 
	for ( i = 0 ; 
	str [ 0 ] && str [ 0 ] != ' ' && str [ 0 ] != '\n' && str [ 0 ] != ',' && str [ 0 ] != '(' && str [ 0 ] != ')' ; 
	i ++ ) { 
		buf [ i ] = * str ++ ; 
		
	} 
	buf [ i ] = '\0' ; 
	while ( str [ 0 ] == ' ' ) str ++ ; 
	if ( str [ 0 ] == ',' || str [ 0 ] == '(' || str [ 0 ] == ')' ) { 
		str ++ ; 
		
	} 
	* strP = str ; 
	return DisASM_numValue_char_p ( buf ) ; 
	
} 

unsigned byte DisASM_fetchL_void_p_p ( void * * strP ) { 
	char * str = * strP ; 
	char buf [ 25 ] ; 
	short int i ; 
	while ( str [ 0 ] == ' ' || str [ 0 ] == '(' || str [ 0 ] == ')' ) str ++ ; 
	if ( str [ 0 ] == ',' ) { 
		str ++ ; 
		* strP = str ; 
		return 1 ; 
		
	} 
	for ( i = 0 ; 
	str [ 0 ] && str [ 0 ] != ' ' && str [ 0 ] != '\n' && str [ 0 ] != ',' && str [ 0 ] != '(' && str [ 0 ] != ')' ; 
	i ++ ) { 
		buf [ i ] = * str ++ ; 
		
	} 
	buf [ i ] = '\0' ; 
	while ( str [ 0 ] == ' ' ) str ++ ; 
	if ( str [ 0 ] == ',' || str [ 0 ] == '(' || str [ 0 ] == ')' ) { 
		str ++ ; 
		
	} 
	* strP = str ; 
	return DisASM_numValue_char_p ( buf ) ; 
	
} 

TString *  DisASM_printHex8_unsigned_byte_short_int ( unsigned byte b , short int i ) { 
char buf[3] = "  ";

		buf[i] = '\0';

		while (--i >= 0) {
			if ((b & 0x0F) <= 9) {
				buf[i] = (char) (b & 0x0F) + '0';
			}
			else {
				buf[i] = (char) (b & 0x0F) - 10 + 'A';
			}

			b = b >> 4;
		}

		return TString_char_p_BOOL(Character_copyValueOf_char_p(buf), FALSE);
	
} 

TString *  DisASM_printHex8_unsigned_byte ( unsigned byte b ) { 
char buf[3] = "  ";
		short i = 2;


		while (--i >= 0) {
			if ((b & 0x0F) <= 9) {
				buf[i] = (char) (b & 0x0F) + '0';
			}
			else {
				buf[i] = (char) (b & 0x0F) - 10 + 'A';
			}

			b = b >> 4;
		}

		return TString_char_p_BOOL(Character_copyValueOf_char_p(buf), FALSE);
	
} 

TString *  DisASM_printBin4_unsigned_byte ( unsigned byte b ) { 
char buf[5] = "    ";
		short i = 4;

		while (--i >= 0) {
			if (b & 0x01) {
				buf[i] = '1';
			}
			else {
				buf[i] = '0';
			}

			b = b >> 1;
		}

		return TString_char_p_BOOL(Character_copyValueOf_char_p(buf), FALSE);
	
} 

unsigned byte DisASM_getByte_char_p_short_int ( char * str , short int shift ) { 
	unsigned byte value = 0 ; 
	{ 
		short int i ; 
		for ( i = 0 ; 
		( shift -= 4 ) >= 0 ; 
		i ++ ) { 
			if ( str [ i ] <= '9' ) { 
				value += ( BYTE ) ( str [ i ] - '0' ) << shift ; 
				
			} 
			else { 
				value += ( BYTE ) ( str [ i ] - 'A' + 10 ) << shift ; 
				
			} 
			
		} 
		
	} 
	return value ; 
	
} 

unsigned byte DisASM_getBin_char_p ( char * str ) { 
	unsigned byte value = 0 ; 
	short int shift = 8 ; 
	{ 
		short int i ; 
		for ( i = 0 ; 
		-- shift >= 0 ; 
		i ++ ) { 
			value += ( BYTE ) ( str [ i ] - '0' ) << shift ; 
			
		} 
		
	} 
	return value ; 
	
} 

unsigned short int DisASM_getHalf_char_p_short_int ( char * str , short int shift ) { 
	unsigned short int value = 0 ; 
	{ 
		short int i ; 
		for ( i = 0 ; 
		( shift -= 4 ) >= 0 ; 
		i ++ ) { 
			if ( str [ i ] <= '9' ) { 
				value += ( ( unsigned short int ) str [ i ] - '0' ) << shift ; 
				
			} 
			else { 
				value += ( ( unsigned short int ) str [ i ] - 'A' + 10 ) << shift ; 
				
			} 
			
		} 
		
	} 
	return value ; 
	
} 
