//Defining class Frame
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Class Frame is a floating window.
 *
 * @author  Frdric Brown
 * @version 1.1, 2002-11-06
 * @since   MDK1.0a
 */
TFrame * TFrame0 ( ) {
	TFrame * this = malloc ( sizeof ( TFrame ) ) ; 
	this -> class = ( char * ) "Frame" ; 
	this -> class_id = 15 ; 
	this -> super = ( void * ) Container ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	//Methods from class Container
	this -> onPaint_ = ( void * ) TContainer_onPaint_ ; 
	this -> onRefresh_ = ( void * ) TContainer_onRefresh_ ; 
	this -> repaintChildren_ = ( void * ) TContainer_repaintChildren_ ; 
	this -> paintChildren_SCR_RECT_p = ( void * ) TContainer_paintChildren_SCR_RECT_p ; 
	this -> checkMnemonic_char = ( void * ) TContainer_checkMnemonic_char ; 
	this -> add_Component = ( void * ) TContainer_add_Component ; 
	this -> remove_Component = ( void * ) TContainer_remove_Component ; 
	this -> toFront_Component = ( void * ) TContainer_toFront_Component ; 
	this -> clean_ = ( void * ) TContainer_clean_ ; 
	//Methods from class Frame
	this -> finalize_ = ( void * ) TFrame_finalize_ ; 
	this -> use_ = ( void * ) TFrame_use_ ; 
	this -> isCursorOverCloseButton_short_int_short_int = ( void * ) TFrame_isCursorOverCloseButton_short_int_short_int ; 
	this -> isCursorOverMinimizeButton_short_int_short_int = ( void * ) TFrame_isCursorOverMinimizeButton_short_int_short_int ; 
	this -> isCursorOverTitleBar_short_int_short_int = ( void * ) TFrame_isCursorOverTitleBar_short_int_short_int ; 
	this -> onClose_ = ( void * ) TFrame_onClose_ ; 
	this -> onMinimize_ = ( void * ) TFrame_onMinimize_ ; 
	this -> onDrag_ = ( void * ) TFrame_onDrag_ ; 
	this -> dispose_ = ( void * ) TFrame_dispose_ ; 
	this -> setVisible_BOOL = ( void * ) TFrame_setVisible_BOOL ; 
	this -> paint_ = ( void * ) TFrame_paint_ ; 
	this -> paintForeground_ = ( void * ) TFrame_paintForeground_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TFrame_isCursorOver_short_int_short_int ; 
	this -> setCaption_String = ( void * ) TFrame_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TFrame_setFont_short_int ; 
	return this ; 
} 
/*
	 * Constructs a new frame.
	 */
TFrame * TFrame_ ( ) {
	TFrame * this = TFrame0 ( ) ; 
	Frame__ ( this ) ; 
	return this ; 
} 
void Frame__ ( struct Frame * this ) { 
	Frame__String ( this , TString_char_p ( ( char * ) "" ) ) ; 
	
} 
/*
	 * Constructs a new frame specifying its caption.
	 *
	 * @param caption the frame's caption.
	 */
TFrame * TFrame_String ( struct String * caption ) {
	TFrame * this = TFrame0 ( ) ; 
	Frame__String ( this , caption ) ; 
	return this ; 
} 
void Frame__String ( struct Frame * this , struct String * caption ) { 
	Container__ ( ( TContainer *  ) this ) ; 
	this -> caption = caption ; 
	this -> font = Font_FONT_SYSTEM ; 
	this -> modal = FALSE ; 
	this -> defaultCloseOperation = Frame_DISPOSE_ON_CLOSE ; 
	this -> visible = FALSE ; 
	this -> movable = TRUE ; 
	this -> closeButtonVisible = TRUE ; 
	this -> minimizeButtonVisible = FALSE ; 
	
} 
/**
     * Free the memory and system ressources used by this Frame.
     */
void TFrame_finalize_ ( struct Frame * this ) { 
	this -> caption -> finalize_ ( this -> caption ) ; 
	Container -> finalize_ ( this ) ; 
	
} 
/**
	 * This method is invoked by the GEM when the user interacts
	 * with the frame.
	 */
void TFrame_use_ ( struct Frame * this ) { 
	short int x = 0 ; 
	short int y = 0 ; 
	TContainer *  ct = this -> parent ; 
	while ( ct ) { 
		x = x + ct -> x ; 
		y = y + ct -> y ; 
		ct = ct -> parent ; 
		
	} 
	if ( this -> isCursorOver_short_int_short_int ( this , x , y ) ) { 
		this -> parent -> toFront_Component ( this -> parent , this ) ; 
		
	} 
	if ( this -> closeButtonVisible && this -> isCursorOverCloseButton_short_int_short_int ( this , x , y ) ) { 
		this -> onClose_ ( this ) ; 
		return ; 
		
	} 
	if ( this -> minimizeButtonVisible && this -> isCursorOverMinimizeButton_short_int_short_int ( this , x , y ) ) { 
		this -> onMinimize_ ( this ) ; 
		return ; 
		
	} 
	if ( this -> movable && this -> isCursorOverTitleBar_short_int_short_int ( this , x , y ) ) { 
		this -> onDrag_ ( this ) ; 
		return ; 
		
	} 
	//this.parent.toFront(this); 
	Container -> use_ ( this ) ; 
	
} 
/**
	 * Indicates if the cursor is over the close button of this frame.
	 *
	 * @param x the reference's horizontal coordinate
	 * @param y	the reference's vertical coordinate
	 * @return true if the cursor is over the close button, false otherwize.
	 */
BOOL TFrame_isCursorOverCloseButton_short_int_short_int ( struct Frame * this , short int x , short int y ) { 
	return GEM_gem -> cursorX >= this -> x + x + this -> width - 12 && GEM_gem -> cursorY >= this -> y + y && GEM_gem -> cursorX < this -> x + x + this -> width && GEM_gem -> cursorY < this -> y + y + 12 ; 
	
} 
/**
	 * Indicates if the cursor is over the minimize button of this frame.
	 *
	 * @param x the reference's horizontal coordinate
	 * @param y	the reference's vertical coordinate
	 * @return true if the cursor is over the minimize button, false otherwize.
	 */
BOOL TFrame_isCursorOverMinimizeButton_short_int_short_int ( struct Frame * this , short int x , short int y ) { 
	return GEM_gem -> cursorX >= this -> x + x + this -> width - 24 && GEM_gem -> cursorY >= this -> y + y && GEM_gem -> cursorX < this -> x + x + this -> width - 12 && GEM_gem -> cursorY < this -> y + y + 12 ; 
	
} 
/**
	 * Indicates if the cursor is over the title bar of this frame.
	 *
	 * @param x the reference's horizontal coordinate
	 * @param y	the reference's vertical coordinate
	 * @return true if the cursor is over the title bar, false otherwize.
	 */
BOOL TFrame_isCursorOverTitleBar_short_int_short_int ( struct Frame * this , short int x , short int y ) { 
	return GEM_gem -> cursorX >= this -> x + x && GEM_gem -> cursorY >= this -> y + y && GEM_gem -> cursorX < this -> x + x + this -> width && GEM_gem -> cursorY < this -> y + y + 12 ; 
	
} 
/**
	 * Called when a CloseEvent occurs.  The method will perform a task
	 * according to the default close operation of this frame.  A CloseEvent
	 * occurs when the user uses the close button of the frame.
	 */
void TFrame_onClose_ ( struct Frame * this ) { 
	switch ( this -> defaultCloseOperation ) { 
		case 0 : { 
			GEM_gem -> setStarted_BOOL ( GEM_gem , FALSE ) ; 
			break ; 
			
		} 
		case 1 : { 
			this -> dispose_ ( this ) ; 
			break ; 
			
		} 
		case 2 : { 
			this -> setVisible_BOOL ( this , FALSE ) ; 
			break ; 
			
		} 
		
	} 
	
} 
/**
	 * Called when a MinimizeEvent occurs.  The method will minimize the window
	 * to the task bar of the desktop.  A MinimizeEvent
	 * occurs when the user uses the minimize button of the frame.
	 */
void TFrame_onMinimize_ ( struct Frame * this ) { 
	GEM_gem -> onMinimize_Frame ( GEM_gem , this ) ; 
	
} 
/**
	 * Called when a DragEvent occurs.  The method will notify the GEM
	 * with a DragEvent.  A DragEvent
	 * occurs when the user click on the title bar.
	 */
void TFrame_onDrag_ ( struct Frame * this ) { 
	GEM_gem -> onDrag_Component ( GEM_gem , this ) ; 
	
} 
/**
	 * Disposes of all ressources used by this frame and
	 * all its children.
	 */
void TFrame_dispose_ ( struct Frame * this ) { 
	if ( this -> parent ) { 
		this -> parent -> remove_Component ( this -> parent , this ) ; 
		
	} 
	this -> clean_ ( this ) ; 
	
} 
/**
	 * Sets the visibility of the frame.
	 *
	 * @param b true if the frame should be visible, false otherwize.
	 */
void TFrame_setVisible_BOOL ( struct Frame * this , BOOL b ) { 
	if ( b && ! this -> parent ) { 
		GEM_gem -> add_Component ( GEM_gem , this ) ; 
		
	} 
	Container -> setVisible_BOOL ( this , b ) ; 
	if ( b && this -> modal ) { 
		GEM_gem -> showModal_Frame ( GEM_gem , this ) ; 
		
	} 
	
} 
/**
	 * Paints the frame.
	 */
void TFrame_paint_ ( struct Frame * this ) { 
int x1 = this->width - 1;

		DrawLine(1, 12, (x1-1), 12, A_NORMAL);

		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(this->font);
		}

		DrawStr(2, 2, this->caption->value, A_NORMAL);

		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(GEM_gem->systemFont);
		}

		if (this->closeButtonVisible) {
			DrawLine((x1-11), 1, (x1-11), 11, A_NORMAL);
			DrawStr((x1-9), 2, "x", A_NORMAL);
		}

		if (this->minimizeButtonVisible) {
			DrawLine((x1-22), 1, (x1-22), 11, A_NORMAL);
			DrawStr((x1-20), 2, "-", A_NORMAL);
		}
	
} 
/**
	 * Paints the foreground of the frame.
	 */
void TFrame_paintForeground_ ( struct Frame * this ) { 
/*int x1 = this->width - 1;
		int y1 = this->height - 1;

		DrawLine(0, 0, x1, 0, A_NORMAL);
		DrawLine(0, y1, x1, y1, A_NORMAL);
		DrawLine(0, 1, 0, (y1-1), A_NORMAL);
		DrawLine(x1, 1, x1, (y1-1), A_NORMAL);*/

		DrawClipRect (&(WIN_RECT){0, 0,  this->width - 1, this->height - 1}, GEM_vScrRect, A_NORMAL);
	
} 
/**
	 * Indicates if the cursor is over this frame.
	 *
	 * @param x the reference's horizontal coordinate
	 * @param y	the reference's vertical coordinate
	 * @return true if the cursor is over the frame, false otherwize.
	 */
BOOL TFrame_isCursorOver_short_int_short_int ( struct Frame * this , short int x , short int y ) { 
	if ( this -> modal ) { 
		return TRUE ; 
		
	} 
	return Container -> isCursorOver_short_int_short_int ( this , x , y ) ; 
	
} 
/**
 	 * Sets the caption of the component.
 	 *
 	 * @param caption The caption of the component.
 	 */
void TFrame_setCaption_String ( struct Frame * this , struct String * caption ) { 
	this -> caption -> finalize_ ( this -> caption ) ; 
	this -> caption = caption ; 
	this -> repaint = TRUE ; 
	if ( this -> visible && this -> parent ) { 
		this -> parent -> onRefresh_ ( this -> parent ) ; 
		
	} 
	
} 
/**
	 * Sets the font for this component's caption.
	 * 
	 * @param font the font for this component's caption.
	 */
void TFrame_setFont_short_int ( struct Frame * this , short int font ) { 
	this -> font = font ; 
	this -> repaint = TRUE ; 
	if ( this -> visible && this -> parent ) { 
		this -> parent -> onRefresh_ ( this -> parent ) ; 
		
	} 
	
} 
