//Defining class GEM
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * The GEM (Graphic Environment Manager) class implements the methods used
 * to manage the Graphic Environment.
 *
 * @author  Frdric Brown
 * @version 1.2, 2004-03-14
 * @since   MDK1.0a
 */
TGEM * TGEM0 ( ) {
	TGEM * this = malloc ( sizeof ( TGEM ) ) ; 
	this -> class = ( char * ) "GEM" ; 
	this -> class_id = 16 ; 
	this -> super = ( void * ) Container ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> paint_ = ( void * ) TComponent_paint_ ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> setVisible_BOOL = ( void * ) TComponent_setVisible_BOOL ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TComponent_isCursorOver_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	//Methods from class Container
	this -> repaintChildren_ = ( void * ) TContainer_repaintChildren_ ; 
	this -> paintForeground_ = ( void * ) TContainer_paintForeground_ ; 
	this -> paintChildren_SCR_RECT_p = ( void * ) TContainer_paintChildren_SCR_RECT_p ; 
	this -> use_ = ( void * ) TContainer_use_ ; 
	this -> checkMnemonic_char = ( void * ) TContainer_checkMnemonic_char ; 
	this -> add_Component = ( void * ) TContainer_add_Component ; 
	this -> remove_Component = ( void * ) TContainer_remove_Component ; 
	this -> toFront_Component = ( void * ) TContainer_toFront_Component ; 
	//Methods from class GEM
	this -> finalize_ = ( void * ) TGEM_finalize_ ; 
	this -> onRefresh_ = ( void * ) TGEM_onRefresh_ ; 
	this -> clean_ = ( void * ) TGEM_clean_ ; 
	this -> setStarted_BOOL = ( void * ) TGEM_setStarted_BOOL ; 
	this -> onPaint_ = ( void * ) TGEM_onPaint_ ; 
	this -> setCursorVisible_BOOL = ( void * ) TGEM_setCursorVisible_BOOL ; 
	this -> setBackground_ = ( void * ) TGEM_setBackground_ ; 
	this -> useCursor_ = ( void * ) TGEM_useCursor_ ; 
	this -> onInterrupt_ = ( void * ) TGEM_onInterrupt_ ; 
	this -> run_ = ( void * ) TGEM_run_ ; 
	this -> showModal_Frame = ( void * ) TGEM_showModal_Frame ; 
	this -> onDrag_Component = ( void * ) TGEM_onDrag_Component ; 
	this -> setFont_short_int = ( void * ) TGEM_setFont_short_int ; 
	this -> onMinimize_Frame = ( void * ) TGEM_onMinimize_Frame ; 
	return this ; 
} 
/*
	 * Constructs a newly allocated Graphic Environment Manager.
	 * This constructor is called at the startup of the application
	 * to initialize GEM.gem (The system default Graphical Environment
	 * Manager).
	 */
TGEM * TGEM_ ( ) {
	TGEM * this = TGEM0 ( ) ; 
	this -> updateUI = TRUE  ; 
	GEM__ ( this ) ; 
	return this ; 
} 
void GEM__ ( struct GEM * this ) { 
	Container__ ( ( TContainer *  ) this ) ; 
	this -> next = NULL ; 
	this -> prev = NULL ; 
	this -> x = 0 ; 
	this -> y = 0 ; 
	this -> width = GEM_LCD_WIDTH ; 
	this -> height = GEM_USABLE_HEIGHT ; 
	this -> started = FALSE ; 
	this -> cursorX = 25 ; 
	this -> cursorY = 25 ; 
	this -> cursorVisible = FALSE ; 
	this -> cursorSpeedX = 3 ; 
	this -> cursorSpeedY = 3 ; 
	this -> port = ( malloc(LCD_SIZE)  ) ; 
	this -> lcd = ( malloc(LCD_SIZE)  ) ; 
	this -> cursorImg = ( malloc(LCD_SIZE)  ) ; 
	//this.dragImg = null; 
	this -> dragCpn = NULL ; 
	//this.kb = new Keyboard(); 
	this -> systemFont = ( FontGetSys()  ) ; 
	//this.desktop = null; 
	//this.desktop = false; 
	this -> startListen = NULL ; 
	this -> minListen = NULL ; 
	this -> size = 0 ; 
	this -> index = - 1 ; 
	this -> capacity = 5 ; 
	this -> array = ( malloc( 5 * sizeof(TInterrupt*))  ) ; 
	
} 
/**
     * Free the memory and system ressources used by this GEM.
     */
void TGEM_finalize_ ( struct GEM * this ) { 
free(this->array);
		free(this->port);
		free(this->lcd);
		free(this->cursorImg);
		if (this->img) {
			free(this->img);
		}
		//this->kb->finalize_(this->kb);
		this->clean_(this);
	
} 
/**
	 * Called when an UpdateEvent occurs.  An update event occurs when a
	 * visible component contained in this container has changed its
	 * appearance.
	 */
void TGEM_onRefresh_ ( struct GEM * this ) { 
	this -> onPaint_ ( this ) ; 
	
} 
/**
	 * Disposes of all ressources used by the Graphic Environment.
	 */
void TGEM_clean_ ( struct GEM * this ) { 
	TComponent *  c ; 
	TComponent *  cn = this -> child ; 
	while ( cn ) { 
		c = cn ; 
		cn = cn -> next ; 
		c -> clean_ ( c ) ; 
		
	} 
	free(this);
		 
} 

/**
	 * Starts or stops this GEM. While the GEM is started, the execution flow become even driven instead of
	 * linear i.e. that instructions are executed when events or interrupts occur instead
	 * of being executed sequentially. When the GEM is stopped, the execution flow continues were it was.
	 *
	 * @param b true if the Graphic Environment should be started, false if the
	 *			Graphic Environment should be stopped.
	 */
void TGEM_setStarted_BOOL ( struct GEM * this , BOOL b ) { 
	this -> started = b ; 
	if ( b ) { 
		LCD_save(this->lcd);
			 this -> run_ ( this ) ; 
		
	} 
	else { 
		LCD_restore(this->lcd);
			 
	} 
	
} 
/**
	 * Called when a PaintEvent occurs to refresh the screen. All
	 * the components are painted.  A PaintEvent occurs when the
	 * aspect of any component is altered.
	 */
void TGEM_onPaint_ ( struct GEM * this ) { 
BOOL b = this->cursorVisible;
		if (this->started && this->updateUI) {
			if (b) {
				this->setCursorVisible_BOOL(this, FALSE);
			}

			LCD_restore(this->lcd);
			this->repaintChildren_(this);

			this->paintChildren_SCR_RECT_p(this, ScrRect);

			if (b) {
				this->setCursorVisible_BOOL(this, TRUE);
			}

			this->repaint = FALSE;
		}
	
} 
/**
	 * Sets the visibility of the cursor.
	 *
	 * @param b true if the cursor should be visible, false otherwise.
	 */
void TGEM_setCursorVisible_BOOL ( struct GEM * this , BOOL b ) { 
short int sprtX;
		short int sprtY;

		this->updateUI = FALSE;

		this->cursorVisible = b;

		if (b) {

			if (this->dragCpn) {
				//BitmapPut (this->cursorX - this->difX, this->cursorY - this->difY, this->dragImg, &this->dragRect, A_REPLACE);
				Sprite8(this->cursorX - this->difX, this->cursorY - this->difY, 8, (unsigned char*)ICON_UPLEFTCORNER, LCD_MEM, SPRT_OR);
				sprtX = this->cursorX - this->difX + this->dragCpn->width - 8;
				sprtY = this->cursorY - this->difY + this->dragCpn->height - 8;
				if (sprtX < GEM_LCD_WIDTH && sprtY < GEM_USABLE_HEIGHT)
					Sprite8(sprtX, sprtY, 8, (unsigned char*)ICON_DNRIGHTCORNER, LCD_MEM, SPRT_OR);

				sprtX = this->cursorX - this->difX + this->dragCpn->width - 8;
				sprtY = this->cursorY - this->difY;
				if (sprtX < GEM_LCD_WIDTH && sprtY < GEM_USABLE_HEIGHT)
					Sprite8(sprtX, sprtY, 8, (unsigned char*)ICON_UPRIGHTCORNER, LCD_MEM, SPRT_OR);

				sprtX = this->cursorX - this->difX;
				sprtY = this->cursorY - this->difY + this->dragCpn->height - 8;
				if (sprtX < GEM_LCD_WIDTH && sprtY < GEM_USABLE_HEIGHT)
					Sprite8(sprtX, sprtY, 8, (unsigned char*)ICON_DNLEFTCORNER, LCD_MEM, SPRT_OR);
			}
			else {
				LCD_save(this->cursorImg);
			}

			Sprite8(this->cursorX, this->cursorY, 8, (unsigned char*)CURSOR_ARROW, LCD_MEM, SPRT_OR);

			Sprite8(this->cursorX, this->cursorY, 8, (unsigned char*)CURSOR_MASK_ARROW, LCD_MEM, SPRT_AND);
		}
		else {
			LCD_restore(this->cursorImg);
		}

		this->updateUI = TRUE;
	
} 
/**
	 * Sets the current screen state as background.
	 *
	 * @since MDK2.11
	 */
void TGEM_setBackground_ ( struct GEM * this ) { 
LCD_save(this->lcd);
		this->repaint = TRUE;
		this->onRefresh_(this);
	
} 
/**
	 * Gives the user the control of the cursor.
	 *
	 * @return The last key read from the keyboard.
	 */
short int TGEM_useCursor_ ( struct GEM * this ) { 
	//Keyboard kb = this.kb; 
	short int key = 0 ; 
	short int x0 = this -> cursorX ; 
	short int y0 = this -> cursorY ; 
	short int pasX = this -> cursorSpeedX ; 
	short int pasY = this -> cursorSpeedY ; 
	//this.interupted = false; 
	this -> setCursorVisible_BOOL ( this , TRUE ) ; 
	do { 
		if ( this -> repaint ) { 
			this -> onPaint_ ( this ) ; 
			
		} 
		Keyboard_flush_ ( ) ; 
		Timer_wait_long_int ( 1 ) ; 
		//key = Keyboard.getKey(1); 
		//kb.checkKeys(); 
		RowRead_enable_ ( ) ; 
		if ( RowRead_key_ANY ) { 
			key = 1 ; 
			if ( RowRead_key_Right ) { 
				x0 = x0 + pasX ; 
				key = 0 ; 
				
			} 
			if ( RowRead_key_Left ) { 
				x0 = x0 - pasX ; 
				key = 0 ; 
				
			} 
			if ( RowRead_key_Up ) { 
				y0 = y0 - pasY ; 
				key = 0 ; 
				
			} 
			if ( RowRead_key_Down ) { 
				y0 = y0 + pasY ; 
				key = 0 ; 
				
			} 
			if ( x0 > GEM_LCD_WIDTH ) { 
				x0 = GEM_LCD_WIDTH - 1 ; 
				
			} 
			else if ( x0 < 0 ) { 
				x0 = 0 ; 
				
			} 
			if ( y0 > GEM_USABLE_HEIGHT ) { 
				y0 = GEM_USABLE_HEIGHT - 1 ; 
				
			} 
			else if ( y0 < 0 ) { 
				y0 = 0 ; 
				
			} 
			this -> setCursorVisible_BOOL ( this , FALSE ) ; 
			this -> cursorX = x0 ; 
			this -> cursorY = y0 ; 
			this -> setCursorVisible_BOOL ( this , TRUE ) ; 
			if ( RowRead_key_ENTER ) { 
				key = Keyboard_KEY_ENTER ; 
				break ; 
				
			} 
			if ( RowRead_key_2nd && ( RowRead_key_F4 || RowRead_key_APPS ) ) { 
				break ; 
				
			} 
			if ( key ) { 
				RowRead_disable_ ( ) ; 
				key = System_read_ ( ) ; 
				//key = Keyboard.getKey(); 
				RowRead_enable_ ( ) ; 
				if ( key >= 'a' && key <= 'z' ) { 
					key -= ( 'a' - 'A' ) ; 
					
				} 
				break ; 
				
			} 
			
		} 
		RowRead_disable_ ( ) ; 
		this -> onInterrupt_ ( this ) ; 
		
	} 
	while ( this -> started ) ; 
	RowRead_disable_ ( ) ; 
	GKeyFlush();
		 this -> setCursorVisible_BOOL ( this , FALSE ) ; 
	return key ; 
	
} 
/**
	 * Called when an InterruptEvent occurs.  This method
	 * checks the current interrupt then increment the interrupts' index.
	 * An InterruptEvent occurs regulary when the GEM is in
	 * waiting state (waiting for an event).
	 */
void TGEM_onInterrupt_ ( struct GEM * this ) { 
	if ( this -> index < 0 ) { 
		return ; 
		
	} 
	if ( this -> index >= this -> size ) { 
		this -> index = 0 ; 
		
	} 
	if ( this -> array [ this -> index ] -> check_ ( this -> array [ this -> index ] ) ) { 
		//this.interupted = true; 
		this -> setCursorVisible_BOOL ( this , FALSE ) ; 
		Interrupt_busy = TRUE ; 
		this -> array [ this -> index ] -> run_ ( this -> array [ this -> index ] ) ; 
		Interrupt_busy = FALSE ; 
		this -> setCursorVisible_BOOL ( this , TRUE ) ; 
		
	} 
	this -> index ++ ; 
	
} 
/**
	 * This method is looping when the GEM is started.
	 */
void TGEM_run_ ( struct GEM * this ) { 
	char key ; 
	if ( this -> startListen ) { 
		this -> startListen -> eventTriggered_Object ( this -> startListen , this ) ; 
		
	} 
	xStartFunc ( MOKAMACRO_MAINPARMS ) ;
		 while ( this -> started && this -> child ) { 
		key = this -> useCursor_ ( this ) ; 
		RowRead_enable_ ( ) ; 
		if ( RowRead_key_2nd && RowRead_key_APPS ) { 
			RowRead_disable_ ( ) ; 
			if ( this -> child ) { 
				this -> toFront_Component ( this , this -> child ) ; 
				
			} 
			
		} 
		else if ( RowRead_key_2nd && RowRead_key_F4 ) { 
			RowRead_disable_ ( ) ; 
			if ( this -> tail && ( instanceof ( ( TObject * ) this -> tail , ( TObject * ) Frame ) ) ) { 
				( ( TFrame *  ) this -> tail ) -> onClose_ ( ( ( TFrame *  ) this -> tail ) ) ; 
				
			} 
			
		} 
		else if ( key == ( KEY_ENTER  ) ) { 
			RowRead_disable_ ( ) ; 
			Interrupt_busy = TRUE ; 
			this -> use_ ( this ) ; 
			Interrupt_busy = FALSE ; 
			
		} 
		else { 
			RowRead_disable_ ( ) ; 
			Interrupt_busy = TRUE ; 
			this -> checkMnemonic_char ( this , key ) ; 
			Interrupt_busy = FALSE ; 
			
		} 
		
	} 
	if ( ! this -> child ) { 
		this -> setStarted_BOOL ( this , FALSE ) ; 
		
	} 
	
} 
/**
	 * This method is called when a Frame is showed in modal mode.
	 *
	 * @param frame The frame to show in modal mode.
	 */
void TGEM_showModal_Frame ( struct GEM * this , struct Frame * frame ) { 
	char key ; 
	BOOL b = Interrupt_busy ; 
	Interrupt_busy = TRUE ; 
	this -> toFront_Component ( this , frame ) ; 
	while ( frame -> modal && frame -> visible && this -> started && this -> child ) { 
		key = this -> useCursor_ ( this ) ; 
		RowRead_enable_ ( ) ; 
		if ( RowRead_key_2nd && RowRead_key_F4 ) { 
			RowRead_disable_ ( ) ; 
			frame -> onClose_ ( frame ) ; 
			
		} 
		else if ( key == ( KEY_ENTER  ) ) { 
			RowRead_disable_ ( ) ; 
			frame -> use_ ( frame ) ; 
			
		} 
		else { 
			RowRead_disable_ ( ) ; 
			frame -> checkMnemonic_char ( frame , key ) ; 
			
		} 
		/*if (!this.child) {
				this.setStarted(false);
			}*/ 
		
	} 
	Interrupt_busy = b ; 
	
} 
/**
	 * Called when a DragEvent occurs to drag and drop a component.
	 * A DragEvent occurs when a component needs to be moved by the
	 * user.
	 *
	 * @param sender the object who triggered the DragEvent.
	 */
void TGEM_onDrag_Component ( struct GEM * this , struct Component * sender ) { 
	//Keyboard kb = this.kb; 
	short int x0 = this -> cursorX ; 
	short int y0 = this -> cursorY ; 
	short int pasX = this -> cursorSpeedX ; 
	short int pasY = this -> cursorSpeedY ; 
	short int x = 0 ; 
	short int y = 0 ; 
	TContainer *  ct = sender -> parent ; 
	BOOL b ; 
	BOOL cont ; 
	while ( ct ) { 
		x = x + ct -> x ; 
		y = y + ct -> y ; 
		ct = ct -> parent ; 
		
	} 
	this->dragRect = (SCR_RECT){{x, y, sender->parent->x + sender->parent->width - 1, sender->parent->y + sender->parent->height - 1}};
		 this -> difX = x0 - sender -> x - x ; 
	this -> difY = y0 - sender -> y - y ; 
	//this.interupted = false; 
	b = this -> updateUI ; 
	this -> updateUI = TRUE ; 
	sender -> setVisible_BOOL ( sender , FALSE ) ; 
	LCD_save ( this->cursorImg ) ; 
	//this.dragImg = sender.img; 
	this -> dragCpn = sender ; 
	this -> setCursorVisible_BOOL ( this , TRUE ) ; 
	do { 
		Timer_wait_long_int ( 1 ) ; 
		//kb.checkSysKeys(); 
		RowRead_enable_ ( ) ; 
		if ( RowRead_key_ANY ) { 
			if ( RowRead_key_Right ) { 
				x0 = x0 + pasX ; 
				
			} 
			if ( RowRead_key_Left ) { 
				x0 = x0 - pasX ; 
				
			} 
			if ( RowRead_key_Up ) { 
				y0 = y0 - pasY ; 
				
			} 
			if ( RowRead_key_Down ) { 
				y0 = y0 + pasY ; 
				
			} 
			if ( x0 > sender -> parent -> width + x ) { 
				x0 = sender -> parent -> width + x - 1 ; 
				
			} 
			//else if (x0 < sender.parent.x) { 
			else if ( x0 - this -> difX - x < sender -> parent -> x ) { 
				x0 = sender -> parent -> x + this -> difX + x ; 
				
			} 
			if ( y0 > sender -> parent -> height + y ) { 
				y0 = sender -> parent -> height + y - 1 ; 
				
			} 
			//else if (y0 < sender.parent.y) { 
			else if ( y0 - this -> difY - y < sender -> parent -> y ) { 
				y0 = sender -> parent -> y + this -> difY + y ; 
				
			} 
			if ( x0 != this -> cursorX || y0 != this -> cursorY ) { 
				this -> setCursorVisible_BOOL ( this , FALSE ) ; 
				this -> cursorX = x0 ; 
				this -> cursorY = y0 ; 
				this -> setCursorVisible_BOOL ( this , TRUE ) ; 
				
			} 
			
		} 
		cont = RowRead_key_ENTER ; 
		RowRead_disable_ ( ) ; 
		//this.onInterrupt(); 
		
	} 
	while ( this -> started && cont ) ; 
	GKeyFlush();
		 this -> setCursorVisible_BOOL ( this , FALSE ) ; 
	//this.dragImg = null; 
	this -> dragCpn = NULL ; 
	sender -> move_short_int_short_int ( sender , ( short int ) x0 - this -> difX - x , ( short int ) y0 - this -> difY - y ) ; 
	this -> updateUI = b ; 
	sender -> setVisible_BOOL ( sender , TRUE ) ; 
	
} 
/**
	 * Sets the system font.
	 *
	 * @param font the new system font.
	 */
void TGEM_setFont_short_int ( struct GEM * this , short int font ) { 
	this -> systemFont = font ; 
	FontSetSys(font);
		 this -> paint_ ( this ) ; 
	
} 
/**
	 * Returns the specified font height.
	 *
	 * @param font the specified font
	 * @return the specified font height
	 */
short int GEM_getFontHeight_short_int ( short int font ) { 
	if ( font == Font_FONT_SYSTEM ) { 
		font = GEM_gem -> systemFont ; 
		
	} 
	switch ( font ) { 
		case Font_FONT_4x6 : { 
			return 6 ; 
			
		} 
		case Font_FONT_6x8 : { 
			return 8 ; 
			
		} 
		case Font_FONT_8x10 : { 
			return 10 ; 
			
		} 
		
	} 
	return 0 ; 
	
} 
/**
	 * Returns the specified font width.
	 *
	 * @param font the specified font
	 * @return the specified font width
	 */
short int GEM_getFontWidth_short_int ( short int font ) { 
	if ( font == Font_FONT_SYSTEM ) { 
		font = GEM_gem -> systemFont ; 
		
	} 
	switch ( font ) { 
		case Font_FONT_4x6 : { 
			return 4 ; 
			
		} 
		case Font_FONT_6x8 : { 
			return 6 ; 
			
		} 
		case Font_FONT_8x10 : { 
			return 8 ; 
			
		} 
		
	} 
	return 0 ; 
	
} 
/**
	 * Called when a MinimizedEvent is triggered. A MinimizeEvent
	 * is triggered when a user wants to minimize a frame.
	 */
void TGEM_onMinimize_Frame ( struct GEM * this , struct Frame * sender ) { 
	if ( this -> minListen ) { 
		this -> minListen -> eventTriggered_Object ( this -> minListen , sender ) ; 
		
	} 
	
} 
