//Defining class Label
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Label is a text label component.
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-11-14
 * @since   MDK1.0a
 */
TLabel * TLabel0 ( ) {
	TLabel * this = malloc ( sizeof ( TLabel ) ) ; 
	this -> class = ( char * ) "Label" ; 
	this -> class_id = 24 ; 
	this -> super = ( void * ) CaptionedComponent ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	//Methods from class EventListener
	//Methods from class Component
	this -> eventTriggered_Object = ( void * ) TComponent_eventTriggered_Object ; 
	this -> onPaint_ = ( void * ) TComponent_onPaint_ ; 
	this -> setBounds_short_int_short_int_short_int_short_int = ( void * ) TComponent_setBounds_short_int_short_int_short_int_short_int ; 
	this -> setY_short_int = ( void * ) TComponent_setY_short_int ; 
	this -> move_short_int_short_int = ( void * ) TComponent_move_short_int_short_int ; 
	this -> setVisible_BOOL = ( void * ) TComponent_setVisible_BOOL ; 
	this -> use_ = ( void * ) TComponent_use_ ; 
	this -> isCursorOver_short_int_short_int = ( void * ) TComponent_isCursorOver_short_int_short_int ; 
	this -> center_ = ( void * ) TComponent_center_ ; 
	this -> toFront_Component = ( void * ) TComponent_toFront_Component ; 
	this -> clean_ = ( void * ) TComponent_clean_ ; 
	this -> checkMnemonic_char = ( void * ) TComponent_checkMnemonic_char ; 
	//Methods from class CaptionedComponent
	this -> finalize_ = ( void * ) TCaptionedComponent_finalize_ ; 
	this -> setCaption_String = ( void * ) TCaptionedComponent_setCaption_String ; 
	this -> setFont_short_int = ( void * ) TCaptionedComponent_setFont_short_int ; 
	//Methods from class Label
	this -> paint_ = ( void * ) TLabel_paint_ ; 
	return this ; 
} 
/*
	 * Constructs a new label.
	 */
TLabel * TLabel_ ( ) {
	TLabel * this = TLabel0 ( ) ; 
	Label__ ( this ) ; 
	return this ; 
} 
void Label__ ( struct Label * this ) { 
	Label__String ( this , TString_char_p ( ( char * ) "" ) ) ; 
	
} 
/*
	 * Constructs a new label specifying its caption.
	 *
	 * @param caption the label's caption.
	 */
TLabel * TLabel_String ( struct String * caption ) {
	TLabel * this = TLabel0 ( ) ; 
	Label__String ( this , caption ) ; 
	return this ; 
} 
void Label__String ( struct Label * this , struct String * caption ) { 
	CaptionedComponent__String ( ( TCaptionedComponent *  ) this , caption ) ; 
	this -> bgColor = Color_WHITE_COLOR ; 
	this -> fgColor = Color_BLACK_COLOR ; 
	
} 
/**
	 * Paints the label.
	 */
void TLabel_paint_ ( struct Label * this ) { 
int h;
		int w;
		
		long int pos;
		long int len = strlen(this->caption->value);
		void* begin = this->caption->value;
		void* end = memchr(begin, this->mnemonic, len);
		
		if (!end) {
			end = memchr(begin, Character_toLowerCase_char(this->mnemonic), len);
		}
		
		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(this->font);
		}
		
		if (this->bgColor != Color_WHITE_COLOR) {
			ScrRectFill(&(SCR_RECT){{0, 0, this->width-1, this->height-1}}, GEM_vScrRect, this->bgColor);
		}
		
		DrawStr(0, 0, this->caption->value, A_NORMAL);
		
		if (this->fgColor == Color_WHITE_COLOR) {
			DrawStr(0, 0, this->caption->value, A_XOR);
		}
		
		
		if (end && this->enabled) {
			h = GEM_getFontHeight_short_int(this->font);
			w = GEM_getFontWidth_short_int(this->font);
			
			pos = (long int)((char*)end - (char*)begin);
			
			DrawLine(w * pos, 1 + h , w * (pos + 1), 1 + h, A_NORMAL);
		}
		
		if (this->font != Font_FONT_SYSTEM) {
			FontSetSys(GEM_gem->systemFont);
		}
	
} 
