//Defining class Object
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2002 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Class <code>Object</code> is the root of the class hierarchy. 
 * Every class has <code>Object</code> as a superclass. All objects
 * implement the methods of this class. 
 *
 * @author  Frdric Brown
 * @version 1.0, 2002-08-29
 * @since   MDK1.0a
 */
TObject * TObject0 ( ) {
	TObject * this = malloc ( sizeof ( TObject ) ) ; 
	this -> class = ( char * ) "Object" ; 
	this -> class_id = 14 ; 
	this -> super = ( void * ) NULL ; 
	//Methods from class Object
	this -> toString_ = ( void * ) TObject_toString_ ; 
	this -> finalize_ = ( void * ) TObject_finalize_ ; 
	return this ; 
} 
/**
     * Returns a string representation of the object. In general, the 
     * <code>toString</code> method returns a string that 
     * "textually represents" this object. The result should 
     * be a concise but informative representation that is easy for a 
     * person to read.
     * It is recommended that all subclasses override this method.
     * <p>
     * The <code>toString</code> method for class <code>Object</code> 
     * returns a string consisting of the name of the class of which the 
     * object is an instance, the at-sign character `<code>@</code>', and 
     * the memory address of the object.
     *
     * @return  a string representation of the object.
     */
TString *  TObject_toString_ ( struct Object * this ) { 
char ptrStr[12];
    	TString* string;
    	int len = strlen(this->class);
    	
    	sprintf(ptrStr, "%lp", this);
    	
    	char* buffer = malloc(len + strlen(ptrStr) + 2);
    	
    	strcpy(buffer, this->class);
    	strcat(buffer, "@");
    	strcat(buffer, ptrStr);
    	
    	string = TString_char_p_BOOL(buffer, FALSE);
    	
    	return string;
    
} 

/**
     * Called on an object to free the memory or system ressources
     * used by this object.
     * A subclass overrides the <code>finalize</code> method to dispose of
     * system resources or to perform other cleanup.
     */
void TObject_finalize_ ( struct Object * this ) { 
free(this);
    
} 
/* Instanciates a new Object. */
TObject * TObject_ ( ) {
	TObject * this = TObject0 ( ) ; 
	Object__ ( this ) ; 
	return this ; 
} 
void Object__ ( struct Object * this ) { 

} 
