//Defining class RowRead
/*
 * This file contains the definition of all the methods of the class and the definition of the built in functions related to the class.
 */
/*
 * QUSOFT MICROSYSTMES
 * Moka
 * Copyright 2004 Frdric Brown
 */
/*
 *  This file is part of Moka API.
 *
 *  Moka API is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Moka API is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Moka API; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Class <code>RowRead</code> is used to get low-level input from the
 * keyboard. Its features are less powerfull than the ones of the Keyboard class,
 * but it is more efficient. The key static methods provided in this class are
 * realy fast ways to determine if a particular key is pressed.
 *
 * @author  Frdric Brown
 * @version 1.0, 2004-03-11
 * @since   MDK2.2
 */
/**
	 * Enable RowRead operation. Saves then disable interupt handlers 1 and 5.
	 */
void RowRead_enable_ ( ) { 
RowRead_save_int_1 = GetIntVec (AUTO_INT_1);
		RowRead_save_int_5 = GetIntVec (AUTO_INT_5);
		SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
		SetIntVec (AUTO_INT_5, DUMMY_HANDLER);
	
} 
/**
	 * Disable RowRead operation. Restores interupt handlers 1 and 5.
	 */
void RowRead_disable_ ( ) { 
SetIntVec (AUTO_INT_1, RowRead_save_int_1);
		SetIntVec (AUTO_INT_5, RowRead_save_int_5);
	
} 
