//Package default
/*
 * This file contains the structure of all the classes of the package, the declaration of all the method of these classes and all their static attributes.
 */
//Structure of class GuiASM
typedef struct GuiASM { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct GuiASM * ) ; 
	void ( * finalize_ ) ( struct GuiASM * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct GuiASM * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct GuiASM * ) ; 
	void ( * paint_ ) ( struct GuiASM * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct GuiASM * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct GuiASM * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct GuiASM * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct GuiASM * , BOOL ) ; 
	void ( * use_ ) ( struct GuiASM * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct GuiASM * , short int , short int ) ; 
	void ( * center_ ) ( struct GuiASM * ) ; 
	struct Component * ( * toFront_Component ) ( struct GuiASM * , struct Component * ) ; 
	void ( * clean_ ) ( struct GuiASM * ) ; 
	void ( * checkMnemonic_char ) ( struct GuiASM * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct GuiASM * ) ; 
	void ( * repaintChildren_ ) ( struct GuiASM * ) ; 
	void ( * paintForeground_ ) ( struct GuiASM * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct GuiASM * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct GuiASM * , struct Component * ) ; 
	void ( * remove_Component ) ( struct GuiASM * , struct Component * ) ; 
	//Fields from class Frame
/** Is this frame movable ?*/
	BOOL movable ; 
/** Is this frame modal ?  Should be only read.*/
	BOOL modal ; 
/** The default close operation for this frame.*/
	short int defaultCloseOperation ; 
/** Is the close button visible ?  Should be only read.*/
	BOOL closeButtonVisible ; 
/** Is the minimize button visible ?  Should be only read.*/
	BOOL minimizeButtonVisible ; 
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class Frame
	BOOL ( * isCursorOverCloseButton_short_int_short_int ) ( struct GuiASM * , short int , short int ) ; 
	BOOL ( * isCursorOverMinimizeButton_short_int_short_int ) ( struct GuiASM * , short int , short int ) ; 
	BOOL ( * isCursorOverTitleBar_short_int_short_int ) ( struct GuiASM * , short int , short int ) ; 
	void ( * onClose_ ) ( struct GuiASM * ) ; 
	void ( * onMinimize_ ) ( struct GuiASM * ) ; 
	void ( * onDrag_ ) ( struct GuiASM * ) ; 
	void ( * dispose_ ) ( struct GuiASM * ) ; 
	void ( * setCaption_String ) ( struct GuiASM * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct GuiASM * , short int ) ; 
	//Fields from class GuiASM

	struct Button * btnDis ; 

	struct TextArea * txtCode ; 

	struct FrameASM * frameASM ; 

	struct FrameAbout * frameAbout ; 

	struct MenuBar * bar ; 

	struct Menu * mFile ; 

	struct MenuItem * itmOpenASM ; 

	struct MenuItem * itmSaveASM ; 

	struct MenuItem * itmOpenBIN ; 

	struct MenuItem * itmSaveBIN ; 

	struct MenuItem * itmQuit ; 

	struct Menu * mView ; 

	struct MenuItem * itmCode ; 

	struct MenuItem * itmASM ; 

	struct Menu * mHelp ; 

	struct MenuItem * itmAbout ; 
	//Methods from class GuiASM
	void ( * setCodeFromASM_String ) ( struct GuiASM * , struct String * ) ; 
} TGuiASM ; 
struct GuiASM * TGuiASM0 ( ) ; 
struct GuiASM * GuiASM ; //Generic GuiASM object prototype
struct GuiASM * TGuiASM_ ( ) ; 
void GuiASM__ ( struct GuiASM * ) ; 
void TGuiASM_eventTriggered_Object ( struct GuiASM * , struct Object * ) ; 
void TGuiASM_setCodeFromASM_String ( struct GuiASM * , struct String * ) ; 
void GuiASM_main_ ( ) ; 
//Structure of class DisASM
typedef struct DisASM { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct DisASM * ) ; 
	void ( * finalize_ ) ( struct DisASM * ) ; 
	//Fields from class DisASM
	//Methods from class DisASM
} TDisASM ; 

char* *  DisASM_opVecStr ; 

struct Format * *  DisASM_opVecForm ; 

#define DisASM_TAILLE_TABLEAUX 256 
void DisASM_static_ ( ) ; 
void DisASM_finally_ ( ) ; 
short int DisASM_trouverIndex_char_p ( char * ) ; 
struct String * DisASM_printHex12_short_int ( short int ) ; 
long int DisASM_numValue_char_p ( char * ) ; 
unsigned byte DisASM_fetchRegister_void_p_p ( void * * ) ; 
unsigned byte DisASM_fetchValue_void_p_p ( void * * ) ; 
unsigned short int DisASM_fetchD_void_p_p ( void * * ) ; 
unsigned byte DisASM_fetchL_void_p_p ( void * * ) ; 
struct String * DisASM_printHex8_unsigned_byte_short_int ( unsigned byte , short int ) ; 
struct String * DisASM_printHex8_unsigned_byte ( unsigned byte ) ; 
struct String * DisASM_printBin4_unsigned_byte ( unsigned byte ) ; 
unsigned byte DisASM_getByte_char_p_short_int ( char * , short int ) ; 
unsigned byte DisASM_getBin_char_p ( char * ) ; 
unsigned short int DisASM_getHalf_char_p_short_int ( char * , short int ) ; 
//Structure of class Format
typedef struct Format { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Format * ) ; 
	void ( * finalize_ ) ( struct Format * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct Format * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct Format * , unsigned byte , char * ) ; 
} TFormat ; 
struct Format * TFormat0 ( ) ; 
struct Format * Format ; //Generic Format object prototype
struct Format * TFormat_ ( ) ; 
void Format__ ( struct Format * ) ; 
//Structure of class FormatRR0
typedef struct FormatRR0 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatRR0 * ) ; 
	void ( * finalize_ ) ( struct FormatRR0 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatRR0 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatRR0 * , unsigned byte , char * ) ; 
	//Fields from class FormatRR0
	//Methods from class FormatRR0
} TFormatRR0 ; 
struct FormatRR0 * TFormatRR00 ( ) ; 
struct FormatRR0 * FormatRR0 ; //Generic FormatRR0 object prototype

struct FormatRR0 *  FormatRR0_form ; 
struct String * TFormatRR0_print_unsigned_byte_char_p ( struct FormatRR0 * , unsigned byte , char * ) ; 
struct String * TFormatRR0_assemble_unsigned_byte_char_p ( struct FormatRR0 * , unsigned byte , char * ) ; 
void FormatRR0_static_ ( ) ; 
void FormatRR0_finally_ ( ) ; 
struct FormatRR0 * TFormatRR0_ ( ) ; 
void FormatRR0__ ( struct FormatRR0 * ) ; 
//Structure of class FormatRR1
typedef struct FormatRR1 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatRR1 * ) ; 
	void ( * finalize_ ) ( struct FormatRR1 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatRR1 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatRR1 * , unsigned byte , char * ) ; 
	//Fields from class FormatRR1
	//Methods from class FormatRR1
} TFormatRR1 ; 
struct FormatRR1 * TFormatRR10 ( ) ; 
struct FormatRR1 * FormatRR1 ; //Generic FormatRR1 object prototype

struct FormatRR1 *  FormatRR1_form ; 
struct String * TFormatRR1_print_unsigned_byte_char_p ( struct FormatRR1 * , unsigned byte , char * ) ; 
struct String * TFormatRR1_assemble_unsigned_byte_char_p ( struct FormatRR1 * , unsigned byte , char * ) ; 
void FormatRR1_static_ ( ) ; 
void FormatRR1_finally_ ( ) ; 
struct FormatRR1 * TFormatRR1_ ( ) ; 
void FormatRR1__ ( struct FormatRR1 * ) ; 
//Structure of class FormatRS0
typedef struct FormatRS0 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatRS0 * ) ; 
	void ( * finalize_ ) ( struct FormatRS0 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatRS0 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatRS0 * , unsigned byte , char * ) ; 
	//Fields from class FormatRS0
	//Methods from class FormatRS0
} TFormatRS0 ; 
struct FormatRS0 * TFormatRS00 ( ) ; 
struct FormatRS0 * FormatRS0 ; //Generic FormatRS0 object prototype

struct FormatRS0 *  FormatRS0_form ; 
struct String * TFormatRS0_print_unsigned_byte_char_p ( struct FormatRS0 * , unsigned byte , char * ) ; 
struct String * TFormatRS0_assemble_unsigned_byte_char_p ( struct FormatRS0 * , unsigned byte , char * ) ; 
void FormatRS0_static_ ( ) ; 
void FormatRS0_finally_ ( ) ; 
struct FormatRS0 * TFormatRS0_ ( ) ; 
void FormatRS0__ ( struct FormatRS0 * ) ; 
//Structure of class FormatRS1
typedef struct FormatRS1 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatRS1 * ) ; 
	void ( * finalize_ ) ( struct FormatRS1 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatRS1 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatRS1 * , unsigned byte , char * ) ; 
	//Fields from class FormatRS1
	//Methods from class FormatRS1
} TFormatRS1 ; 
struct FormatRS1 * TFormatRS10 ( ) ; 
struct FormatRS1 * FormatRS1 ; //Generic FormatRS1 object prototype

struct FormatRS1 *  FormatRS1_form ; 
struct String * TFormatRS1_print_unsigned_byte_char_p ( struct FormatRS1 * , unsigned byte , char * ) ; 
struct String * TFormatRS1_assemble_unsigned_byte_char_p ( struct FormatRS1 * , unsigned byte , char * ) ; 
void FormatRS1_static_ ( ) ; 
void FormatRS1_finally_ ( ) ; 
struct FormatRS1 * TFormatRS1_ ( ) ; 
void FormatRS1__ ( struct FormatRS1 * ) ; 
//Structure of class FormatRS2
typedef struct FormatRS2 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatRS2 * ) ; 
	void ( * finalize_ ) ( struct FormatRS2 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatRS2 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatRS2 * , unsigned byte , char * ) ; 
	//Fields from class FormatRS2
	//Methods from class FormatRS2
} TFormatRS2 ; 
struct FormatRS2 * TFormatRS20 ( ) ; 
struct FormatRS2 * FormatRS2 ; //Generic FormatRS2 object prototype

struct FormatRS2 *  FormatRS2_form ; 
struct String * TFormatRS2_print_unsigned_byte_char_p ( struct FormatRS2 * , unsigned byte , char * ) ; 
struct String * TFormatRS2_assemble_unsigned_byte_char_p ( struct FormatRS2 * , unsigned byte , char * ) ; 
void FormatRS2_static_ ( ) ; 
void FormatRS2_finally_ ( ) ; 
struct FormatRS2 * TFormatRS2_ ( ) ; 
void FormatRS2__ ( struct FormatRS2 * ) ; 
//Structure of class FormatRX0
typedef struct FormatRX0 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatRX0 * ) ; 
	void ( * finalize_ ) ( struct FormatRX0 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatRX0 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatRX0 * , unsigned byte , char * ) ; 
	//Fields from class FormatRX0
	//Methods from class FormatRX0
} TFormatRX0 ; 
struct FormatRX0 * TFormatRX00 ( ) ; 
struct FormatRX0 * FormatRX0 ; //Generic FormatRX0 object prototype

struct FormatRX0 *  FormatRX0_form ; 
struct String * TFormatRX0_print_unsigned_byte_char_p ( struct FormatRX0 * , unsigned byte , char * ) ; 
struct String * TFormatRX0_assemble_unsigned_byte_char_p ( struct FormatRX0 * , unsigned byte , char * ) ; 
void FormatRX0_static_ ( ) ; 
void FormatRX0_finally_ ( ) ; 
struct FormatRX0 * TFormatRX0_ ( ) ; 
void FormatRX0__ ( struct FormatRX0 * ) ; 
//Structure of class FormatSI0
typedef struct FormatSI0 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatSI0 * ) ; 
	void ( * finalize_ ) ( struct FormatSI0 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatSI0 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatSI0 * , unsigned byte , char * ) ; 
	//Fields from class FormatSI0
	//Methods from class FormatSI0
} TFormatSI0 ; 
struct FormatSI0 * TFormatSI00 ( ) ; 
struct FormatSI0 * FormatSI0 ; //Generic FormatSI0 object prototype

struct FormatSI0 *  FormatSI0_form ; 
struct String * TFormatSI0_print_unsigned_byte_char_p ( struct FormatSI0 * , unsigned byte , char * ) ; 
struct String * TFormatSI0_assemble_unsigned_byte_char_p ( struct FormatSI0 * , unsigned byte , char * ) ; 
void FormatSI0_static_ ( ) ; 
void FormatSI0_finally_ ( ) ; 
struct FormatSI0 * TFormatSI0_ ( ) ; 
void FormatSI0__ ( struct FormatSI0 * ) ; 
//Structure of class FormatSS0
typedef struct FormatSS0 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatSS0 * ) ; 
	void ( * finalize_ ) ( struct FormatSS0 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatSS0 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatSS0 * , unsigned byte , char * ) ; 
	//Fields from class FormatSS0
	//Methods from class FormatSS0
} TFormatSS0 ; 
struct FormatSS0 * TFormatSS00 ( ) ; 
struct FormatSS0 * FormatSS0 ; //Generic FormatSS0 object prototype

struct FormatSS0 *  FormatSS0_form ; 
struct String * TFormatSS0_print_unsigned_byte_char_p ( struct FormatSS0 * , unsigned byte , char * ) ; 
struct String * TFormatSS0_assemble_unsigned_byte_char_p ( struct FormatSS0 * , unsigned byte , char * ) ; 
void FormatSS0_static_ ( ) ; 
void FormatSS0_finally_ ( ) ; 
struct FormatSS0 * TFormatSS0_ ( ) ; 
void FormatSS0__ ( struct FormatSS0 * ) ; 
//Structure of class FormatSS1
typedef struct FormatSS1 { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FormatSS1 * ) ; 
	void ( * finalize_ ) ( struct FormatSS1 * ) ; 
	//Fields from class Format
	//Methods from class Format
	struct String * ( * print_unsigned_byte_char_p ) ( struct FormatSS1 * , unsigned byte , char * ) ; 
	struct String * ( * assemble_unsigned_byte_char_p ) ( struct FormatSS1 * , unsigned byte , char * ) ; 
	//Fields from class FormatSS1
	//Methods from class FormatSS1
} TFormatSS1 ; 
struct FormatSS1 * TFormatSS10 ( ) ; 
struct FormatSS1 * FormatSS1 ; //Generic FormatSS1 object prototype

struct FormatSS1 *  FormatSS1_form ; 
struct String * TFormatSS1_print_unsigned_byte_char_p ( struct FormatSS1 * , unsigned byte , char * ) ; 
struct String * TFormatSS1_assemble_unsigned_byte_char_p ( struct FormatSS1 * , unsigned byte , char * ) ; 
void FormatSS1_static_ ( ) ; 
void FormatSS1_finally_ ( ) ; 
struct FormatSS1 * TFormatSS1_ ( ) ; 
void FormatSS1__ ( struct FormatSS1 * ) ; 
//Structure of class FrameAbout
typedef struct FrameAbout { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FrameAbout * ) ; 
	void ( * finalize_ ) ( struct FrameAbout * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct FrameAbout * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct FrameAbout * ) ; 
	void ( * paint_ ) ( struct FrameAbout * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct FrameAbout * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct FrameAbout * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct FrameAbout * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct FrameAbout * , BOOL ) ; 
	void ( * use_ ) ( struct FrameAbout * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct FrameAbout * , short int , short int ) ; 
	void ( * center_ ) ( struct FrameAbout * ) ; 
	struct Component * ( * toFront_Component ) ( struct FrameAbout * , struct Component * ) ; 
	void ( * clean_ ) ( struct FrameAbout * ) ; 
	void ( * checkMnemonic_char ) ( struct FrameAbout * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct FrameAbout * ) ; 
	void ( * repaintChildren_ ) ( struct FrameAbout * ) ; 
	void ( * paintForeground_ ) ( struct FrameAbout * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct FrameAbout * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct FrameAbout * , struct Component * ) ; 
	void ( * remove_Component ) ( struct FrameAbout * , struct Component * ) ; 
	//Fields from class Frame
/** Is this frame movable ?*/
	BOOL movable ; 
/** Is this frame modal ?  Should be only read.*/
	BOOL modal ; 
/** The default close operation for this frame.*/
	short int defaultCloseOperation ; 
/** Is the close button visible ?  Should be only read.*/
	BOOL closeButtonVisible ; 
/** Is the minimize button visible ?  Should be only read.*/
	BOOL minimizeButtonVisible ; 
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class Frame
	BOOL ( * isCursorOverCloseButton_short_int_short_int ) ( struct FrameAbout * , short int , short int ) ; 
	BOOL ( * isCursorOverMinimizeButton_short_int_short_int ) ( struct FrameAbout * , short int , short int ) ; 
	BOOL ( * isCursorOverTitleBar_short_int_short_int ) ( struct FrameAbout * , short int , short int ) ; 
	void ( * onClose_ ) ( struct FrameAbout * ) ; 
	void ( * onMinimize_ ) ( struct FrameAbout * ) ; 
	void ( * onDrag_ ) ( struct FrameAbout * ) ; 
	void ( * dispose_ ) ( struct FrameAbout * ) ; 
	void ( * setCaption_String ) ( struct FrameAbout * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct FrameAbout * , short int ) ; 
	//Fields from class FrameAbout

	struct TextArea * txtAbout ; 

	struct Button * btnOk ; 
	//Methods from class FrameAbout
} TFrameAbout ; 
struct FrameAbout * TFrameAbout0 ( ) ; 
struct FrameAbout * FrameAbout ; //Generic FrameAbout object prototype
struct FrameAbout * TFrameAbout_ ( ) ; 
void FrameAbout__ ( struct FrameAbout * ) ; 
void TFrameAbout_eventTriggered_Object ( struct FrameAbout * , struct Object * ) ; 
//Structure of class FrameASM
typedef struct FrameASM { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct FrameASM * ) ; 
	void ( * finalize_ ) ( struct FrameASM * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct FrameASM * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct FrameASM * ) ; 
	void ( * paint_ ) ( struct FrameASM * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct FrameASM * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct FrameASM * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct FrameASM * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct FrameASM * , BOOL ) ; 
	void ( * use_ ) ( struct FrameASM * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct FrameASM * , short int , short int ) ; 
	void ( * center_ ) ( struct FrameASM * ) ; 
	struct Component * ( * toFront_Component ) ( struct FrameASM * , struct Component * ) ; 
	void ( * clean_ ) ( struct FrameASM * ) ; 
	void ( * checkMnemonic_char ) ( struct FrameASM * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct FrameASM * ) ; 
	void ( * repaintChildren_ ) ( struct FrameASM * ) ; 
	void ( * paintForeground_ ) ( struct FrameASM * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct FrameASM * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct FrameASM * , struct Component * ) ; 
	void ( * remove_Component ) ( struct FrameASM * , struct Component * ) ; 
	//Fields from class Frame
/** Is this frame movable ?*/
	BOOL movable ; 
/** Is this frame modal ?  Should be only read.*/
	BOOL modal ; 
/** The default close operation for this frame.*/
	short int defaultCloseOperation ; 
/** Is the close button visible ?  Should be only read.*/
	BOOL closeButtonVisible ; 
/** Is the minimize button visible ?  Should be only read.*/
	BOOL minimizeButtonVisible ; 
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class Frame
	BOOL ( * isCursorOverCloseButton_short_int_short_int ) ( struct FrameASM * , short int , short int ) ; 
	BOOL ( * isCursorOverMinimizeButton_short_int_short_int ) ( struct FrameASM * , short int , short int ) ; 
	BOOL ( * isCursorOverTitleBar_short_int_short_int ) ( struct FrameASM * , short int , short int ) ; 
	void ( * onClose_ ) ( struct FrameASM * ) ; 
	void ( * onMinimize_ ) ( struct FrameASM * ) ; 
	void ( * onDrag_ ) ( struct FrameASM * ) ; 
	void ( * dispose_ ) ( struct FrameASM * ) ; 
	void ( * setCaption_String ) ( struct FrameASM * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct FrameASM * , short int ) ; 
	//Fields from class FrameASM

	struct GuiASM * frameCode ; 

	struct TextArea * txtASM ; 

	struct Button * btnASM ; 
	//Methods from class FrameASM
	void ( * setASMFromCode_String ) ( struct FrameASM * , struct String * ) ; 
} TFrameASM ; 
struct FrameASM * TFrameASM0 ( ) ; 
struct FrameASM * FrameASM ; //Generic FrameASM object prototype
struct FrameASM * TFrameASM_GuiASM ( struct GuiASM * ) ; 
void FrameASM__GuiASM ( struct FrameASM * , struct GuiASM * ) ; 
void TFrameASM_eventTriggered_Object ( struct FrameASM * , struct Object * ) ; 
void TFrameASM_setASMFromCode_String ( struct FrameASM * , struct String * ) ; 
