//Package moka.lang
/*
 * This file contains the structure of all the classes of the package, the declaration of all the method of these classes and all their static attributes.
 */
//Structure of class System
typedef struct System { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct System * ) ; 
	void ( * finalize_ ) ( struct System * ) ; 
	//Fields from class System
	//Methods from class System
} TSystem ; 
/**The calculator model (TI-89, TI-92 or V200)*/
short int System_CALCULATOR ; 
/** The number added to the key code if the Diamond key is pressed with it.*/
short int System_KEY_DIAMOND ; 
/** Key code for the down arrow key.*/
short int System_KEY_DOWN ; 
/** Key code for the left arrow key.*/
short int System_KEY_LEFT ; 
/** Key code for the right arrow key.*/
short int System_KEY_RIGHT ; 
/** Key code for the up arrow key.*/
short int System_KEY_UP ; 
//Structure of class String
typedef struct String { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct String * ) ; 
	void ( * finalize_ ) ( struct String * ) ; 
	//Fields from class String
/** The value used for character storage. */
	char * value ; 
/** A flag used to determine if the value is given by a reference.*/
	BOOL ref ; 
	//Methods from class String
	struct String * ( * append_String ) ( struct String * , struct String * ) ; 
	struct String * ( * append_char ) ( struct String * , char ) ; 
	struct String * ( * append_short_int ) ( struct String * , short int ) ; 
	struct String * ( * concat_String ) ( struct String * , struct String * ) ; 
	struct String * ( * delete_long_int_long_int ) ( struct String * , long int , long int ) ; 
	struct String * ( * substring_long_int_long_int ) ( struct String * , long int , long int ) ; 
} TString ; 
struct String * TString0 ( ) ; 
struct String * String ; //Generic String object prototype
struct String * TString_ ( ) ; 
void String__ ( struct String * ) ; 
struct String * TString_String ( struct String * ) ; 
void String__String ( struct String * , struct String * ) ; 
struct String * TString_char_p ( char * ) ; 
void String__char_p ( struct String * , char * ) ; 
struct String * TString_char_p_BOOL ( char * , BOOL ) ; 
void String__char_p_BOOL ( struct String * , char * , BOOL ) ; 
struct String * TString_append_String ( struct String * , struct String * ) ; 
struct String * TString_append_char ( struct String * , char ) ; 
struct String * TString_append_short_int ( struct String * , short int ) ; 
struct String * TString_concat_String ( struct String * , struct String * ) ; 
struct String * TString_delete_long_int_long_int ( struct String * , long int , long int ) ; 
struct String * TString_substring_long_int_long_int ( struct String * , long int , long int ) ; 
struct String * TString_toString_ ( struct String * ) ; 
void TString_finalize_ ( struct String * ) ; 
struct String * String_valueOf_char ( char ) ; 
struct String * String_valueOf_short_int ( short int ) ; 
//Structure of class Character
typedef struct Character { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Character * ) ; 
	void ( * finalize_ ) ( struct Character * ) ; 
	//Fields from class Character
/**
     * The value of the <code>Character</code>.
     */
	char value ; 
	//Methods from class Character
} TCharacter ; 
char * Character_concat_char_p_char_p ( char * , char * ) ; 
char * Character_copyValueOf_char_p ( char * ) ; 
BOOL Character_isDigit_char ( char ) ; 
BOOL Character_isLetter_char ( char ) ; 
BOOL Character_isLowerCase_char ( char ) ; 
BOOL Character_isUpperCase_char ( char ) ; 
char Character_toLowerCase_char ( char ) ; 
//Structure of class Integer
typedef struct Integer { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Integer * ) ; 
	void ( * finalize_ ) ( struct Integer * ) ; 
	//Fields from class Integer
/**
	* The value of the Integer.
	*/
	long int value ; 
	//Methods from class Integer
} TInteger ; 
long int Integer_parseInt_String ( struct String * ) ; 
//Structure of class Object
typedef struct Object { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Object * ) ; 
	void ( * finalize_ ) ( struct Object * ) ; 
} TObject ; 
struct Object * TObject0 ( ) ; 
struct Object * Object ; //Generic Object object prototype
struct String * TObject_toString_ ( struct Object * ) ; 
void TObject_finalize_ ( struct Object * ) ; 
struct Object * TObject_ ( ) ; 
void Object__ ( struct Object * ) ; 
//Structure of class Long
typedef struct Long { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Long * ) ; 
	void ( * finalize_ ) ( struct Long * ) ; 
	//Fields from class Long
/**
	* The value of the Long.
	*/
	long long int value ; 
	//Methods from class Long
} TLong ; 
BOOL Long_isLong_String ( struct String * ) ; 
//Structure of class Double
typedef struct Double { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Double * ) ; 
	void ( * finalize_ ) ( struct Double * ) ; 
	//Fields from class Double
/**
	* The value of the Double.
	*/
	double value ; 
	//Methods from class Double
} TDouble ; 
double Double_parseDouble_String ( struct String * ) ; 
BOOL Double_isDouble_String ( struct String * ) ; 
