//Package moka.x
/*
 * This file contains the structure of all the classes of the package, the declaration of all the method of these classes and all their static attributes.
 */
//Structure of class Frame
typedef struct Frame { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Frame * ) ; 
	void ( * finalize_ ) ( struct Frame * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct Frame * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct Frame * ) ; 
	void ( * paint_ ) ( struct Frame * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct Frame * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct Frame * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct Frame * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct Frame * , BOOL ) ; 
	void ( * use_ ) ( struct Frame * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct Frame * , short int , short int ) ; 
	void ( * center_ ) ( struct Frame * ) ; 
	struct Component * ( * toFront_Component ) ( struct Frame * , struct Component * ) ; 
	void ( * clean_ ) ( struct Frame * ) ; 
	void ( * checkMnemonic_char ) ( struct Frame * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct Frame * ) ; 
	void ( * repaintChildren_ ) ( struct Frame * ) ; 
	void ( * paintForeground_ ) ( struct Frame * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct Frame * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct Frame * , struct Component * ) ; 
	void ( * remove_Component ) ( struct Frame * , struct Component * ) ; 
	//Fields from class Frame
/** Is this frame movable ?*/
	BOOL movable ; 
/** Is this frame modal ?  Should be only read.*/
	BOOL modal ; 
/** The default close operation for this frame.*/
	short int defaultCloseOperation ; 
/** Is the close button visible ?  Should be only read.*/
	BOOL closeButtonVisible ; 
/** Is the minimize button visible ?  Should be only read.*/
	BOOL minimizeButtonVisible ; 
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class Frame
	BOOL ( * isCursorOverCloseButton_short_int_short_int ) ( struct Frame * , short int , short int ) ; 
	BOOL ( * isCursorOverMinimizeButton_short_int_short_int ) ( struct Frame * , short int , short int ) ; 
	BOOL ( * isCursorOverTitleBar_short_int_short_int ) ( struct Frame * , short int , short int ) ; 
	void ( * onClose_ ) ( struct Frame * ) ; 
	void ( * onMinimize_ ) ( struct Frame * ) ; 
	void ( * onDrag_ ) ( struct Frame * ) ; 
	void ( * dispose_ ) ( struct Frame * ) ; 
	void ( * setCaption_String ) ( struct Frame * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct Frame * , short int ) ; 
} TFrame ; 
struct Frame * TFrame0 ( ) ; 
struct Frame * Frame ; //Generic Frame object prototype
/** Indicate that the default close operation disposes of this frame.*/
#define Frame_DISPOSE_ON_CLOSE 1 
/** Indicate that the default close operation hides the frame.*/
#define Frame_HIDE_ON_CLOSE 2 
struct Frame * TFrame_ ( ) ; 
void Frame__ ( struct Frame * ) ; 
struct Frame * TFrame_String ( struct String * ) ; 
void Frame__String ( struct Frame * , struct String * ) ; 
void TFrame_finalize_ ( struct Frame * ) ; 
void TFrame_use_ ( struct Frame * ) ; 
BOOL TFrame_isCursorOverCloseButton_short_int_short_int ( struct Frame * , short int , short int ) ; 
BOOL TFrame_isCursorOverMinimizeButton_short_int_short_int ( struct Frame * , short int , short int ) ; 
BOOL TFrame_isCursorOverTitleBar_short_int_short_int ( struct Frame * , short int , short int ) ; 
void TFrame_onClose_ ( struct Frame * ) ; 
void TFrame_onMinimize_ ( struct Frame * ) ; 
void TFrame_onDrag_ ( struct Frame * ) ; 
void TFrame_dispose_ ( struct Frame * ) ; 
void TFrame_setVisible_BOOL ( struct Frame * , BOOL ) ; 
void TFrame_paint_ ( struct Frame * ) ; 
void TFrame_paintForeground_ ( struct Frame * ) ; 
BOOL TFrame_isCursorOver_short_int_short_int ( struct Frame * , short int , short int ) ; 
void TFrame_setCaption_String ( struct Frame * , struct String * ) ; 
void TFrame_setFont_short_int ( struct Frame * , short int ) ; 
//Structure of class GEM
typedef struct GEM { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct GEM * ) ; 
	void ( * finalize_ ) ( struct GEM * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct GEM * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct GEM * ) ; 
	void ( * paint_ ) ( struct GEM * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct GEM * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct GEM * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct GEM * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct GEM * , BOOL ) ; 
	void ( * use_ ) ( struct GEM * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct GEM * , short int , short int ) ; 
	void ( * center_ ) ( struct GEM * ) ; 
	struct Component * ( * toFront_Component ) ( struct GEM * , struct Component * ) ; 
	void ( * clean_ ) ( struct GEM * ) ; 
	void ( * checkMnemonic_char ) ( struct GEM * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct GEM * ) ; 
	void ( * repaintChildren_ ) ( struct GEM * ) ; 
	void ( * paintForeground_ ) ( struct GEM * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct GEM * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct GEM * , struct Component * ) ; 
	void ( * remove_Component ) ( struct GEM * , struct Component * ) ; 
	//Fields from class GEM
/** The state of the lcd before x was started.*/
	void * lcd ; 

/** The array of interrupts.*/
	struct Interrupt * * array ; 
/** The number of interrupts.*/
	long int size ; 
/** The actual interrupts' index.*/
	long int index ; 
/** The capacity of the interrupts' array.*/
	long int capacity ; 

/** The difference between the cursor horizontal coordinate and the dragged component horizontal coordinate.*/
	short int difX ; 
/** The difference between the cursor vertical coordinate and the dragged component vertical coordinate.*/
	short int difY ; 
/** The context of the dragged component.*/
	SCR_RECT dragRect ; 
/** The image behind the cursor.*/
	void * cursorImg ; 

/** The component being dragged.*/
	struct Component * dragCpn ; 
/** The virtual screen buffer.*/
	void * port ; 
/** Is the Graphic Environment started ? Should be only read.*/
	BOOL started ; 
/** The cursor x position. Should be only read.*/
	short int cursorX ; 
/** The cursor y position. Should be only read.*/
	short int cursorY ; 
/** Is the cursor visible ? Should be only read.*/
	short int cursorVisible ; 
/** The horizontal speed of the cursor.*/
	short int cursorSpeedX ; 
/** The vertical speed of the cursor.*/
	short int cursorSpeedY ; 
/** The ssytem font.  Should be only read.*/
	short int systemFont ; 
/** Is the user interface should be updated ?*/
	BOOL updateUI ; 
/** The event listener notified when the Graphic Environment starts.*/
	struct EventListener * startListen ; 
/** The event listener notified when a frame is minimized.*/
	struct EventListener * minListen ; 
	//Methods from class GEM
	void ( * setStarted_BOOL ) ( struct GEM * , BOOL ) ; 
	void ( * setCursorVisible_BOOL ) ( struct GEM * , BOOL ) ; 
	void ( * setBackground_ ) ( struct GEM * ) ; 
	short int ( * useCursor_ ) ( struct GEM * ) ; 
	void ( * onInterrupt_ ) ( struct GEM * ) ; 
	void ( * run_ ) ( struct GEM * ) ; 
	void ( * showModal_Frame ) ( struct GEM * , struct Frame * ) ; 
	void ( * onDrag_Component ) ( struct GEM * , struct Component * ) ; 
	void ( * setFont_short_int ) ( struct GEM * , short int ) ; 
	void ( * onMinimize_Frame ) ( struct GEM * , struct Frame * ) ; 
} TGEM ; 
struct GEM * TGEM0 ( ) ; 
struct GEM * GEM ; //Generic GEM object prototype
/** The instance of the Graphic Environment Manager. Should be only read.*/
struct GEM *  GEM_gem ; 
/** Height of the screen in pixels (100 on TI-89, 128 on TI-92 Plus or V200).*/
short int GEM_LCD_HEIGHT ; 
/** Width of the screen in pixels (160 on TI-89, 240 on TI-92 Plus or V200).*/
short int GEM_LCD_WIDTH ; 
/** The usable height of the screen (94 on TI-89, 122 on TI-92 Plus or V200)*/
short int GEM_USABLE_HEIGHT ; 
/** The virtual screen SCR_RECT.*/
SCR_RECT*  GEM_vScrRect ; 
struct GEM * TGEM_ ( ) ; 
void GEM__ ( struct GEM * ) ; 
void TGEM_finalize_ ( struct GEM * ) ; 
void TGEM_onRefresh_ ( struct GEM * ) ; 
void TGEM_clean_ ( struct GEM * ) ; 
void TGEM_setStarted_BOOL ( struct GEM * , BOOL ) ; 
void TGEM_onPaint_ ( struct GEM * ) ; 
void TGEM_setCursorVisible_BOOL ( struct GEM * , BOOL ) ; 
void TGEM_setBackground_ ( struct GEM * ) ; 
short int TGEM_useCursor_ ( struct GEM * ) ; 
void TGEM_onInterrupt_ ( struct GEM * ) ; 
void TGEM_run_ ( struct GEM * ) ; 
void TGEM_showModal_Frame ( struct GEM * , struct Frame * ) ; 
void TGEM_onDrag_Component ( struct GEM * , struct Component * ) ; 
void TGEM_setFont_short_int ( struct GEM * , short int ) ; 
short int GEM_getFontHeight_short_int ( short int ) ; 
short int GEM_getFontWidth_short_int ( short int ) ; 
void TGEM_onMinimize_Frame ( struct GEM * , struct Frame * ) ; 
//Structure of class Font
typedef struct Font { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Font * ) ; 
	void ( * finalize_ ) ( struct Font * ) ; 
	//Fields from class Font
	//Methods from class Font
} TFont ; 
/** Use a proportional small font.*/
#define Font_FONT_4x6 0 
/** Use a fixed-width medium font.*/
#define Font_FONT_6x8 1 
/** Use a fixed-width large font.*/
#define Font_FONT_8x10 2 
/** Use the current system font.*/
#define Font_FONT_SYSTEM 3 
//Structure of class Button
typedef struct Button { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Button * ) ; 
	void ( * finalize_ ) ( struct Button * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct Button * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct Button * ) ; 
	void ( * paint_ ) ( struct Button * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct Button * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct Button * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct Button * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct Button * , BOOL ) ; 
	void ( * use_ ) ( struct Button * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct Button * , short int , short int ) ; 
	void ( * center_ ) ( struct Button * ) ; 
	struct Component * ( * toFront_Component ) ( struct Button * , struct Component * ) ; 
	void ( * clean_ ) ( struct Button * ) ; 
	void ( * checkMnemonic_char ) ( struct Button * , char ) ; 
	//Fields from class CaptionedComponent
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class CaptionedComponent
	void ( * setCaption_String ) ( struct Button * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct Button * , short int ) ; 
	//Fields from class Button
/** The style for this component.  Should be only read.*/
	short int style ; 
	//Methods from class Button
} TButton ; 
struct Button * TButton0 ( ) ; 
struct Button * Button ; //Generic Button object prototype
struct Button * TButton_String ( struct String * ) ; 
void Button__String ( struct Button * , struct String * ) ; 
void TButton_paint_ ( struct Button * ) ; 
//Structure of class TextArea
typedef struct TextArea { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct TextArea * ) ; 
	void ( * finalize_ ) ( struct TextArea * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct TextArea * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct TextArea * ) ; 
	void ( * paint_ ) ( struct TextArea * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct TextArea * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct TextArea * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct TextArea * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct TextArea * , BOOL ) ; 
	void ( * use_ ) ( struct TextArea * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct TextArea * , short int , short int ) ; 
	void ( * center_ ) ( struct TextArea * ) ; 
	struct Component * ( * toFront_Component ) ( struct TextArea * , struct Component * ) ; 
	void ( * clean_ ) ( struct TextArea * ) ; 
	void ( * checkMnemonic_char ) ( struct TextArea * , char ) ; 
	//Fields from class CaptionedComponent
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class CaptionedComponent
	void ( * setCaption_String ) ( struct TextArea * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct TextArea * , short int ) ; 
	//Fields from class TextArea
/** The number of character this TextField should accept. Should be > 0.*/
	short int maxLength ; 
/** Should the words be warped ? Should be only read.*/
	BOOL warp ; 
/** Is the vertical scroll bar should be visible ? Should be only read. Use setVScrollVisible to set value. */
	BOOL vScrollVisible ; 
/** The index of the first line. Should be only read. Use setScrollLine to set value. */
	long int scrollLine ; 
/** Is the text editable ? */
	BOOL editable ; 
/* The total number of lines. */
	long int totalLines ; 
/* The first char visible. */
	long int firstIndex ; 
/* The last char visible. */
	long int lastIndex ; 
	//Methods from class TextArea
	void ( * setScrollLine_long_int ) ( struct TextArea * , long int ) ; 
	void ( * printTextWarp_char_p_short_int_short_int ) ( struct TextArea * , char * , short int , short int ) ; 
	short int ( * getNbC_ ) ( struct TextArea * ) ; 
	void ( * printTextNoWarp_char_p_short_int_short_int_short_int ) ( struct TextArea * , char * , short int , short int , short int ) ; 
} TTextArea ; 
struct TextArea * TTextArea0 ( ) ; 
struct TextArea * TextArea ; //Generic TextArea object prototype
struct TextArea * TTextArea_ ( ) ; 
void TextArea__ ( struct TextArea * ) ; 
struct TextArea * TTextArea_String ( struct String * ) ; 
void TextArea__String ( struct TextArea * , struct String * ) ; 
void TTextArea_setScrollLine_long_int ( struct TextArea * , long int ) ; 
void TTextArea_paint_ ( struct TextArea * ) ; 
char * TextArea_returnToken_char_p_char_p ( char * , char * ) ; 
void TTextArea_printTextWarp_char_p_short_int_short_int ( struct TextArea * , char * , short int , short int ) ; 
short int TTextArea_getNbC_ ( struct TextArea * ) ; 
void TTextArea_printTextNoWarp_char_p_short_int_short_int_short_int ( struct TextArea * , char * , short int , short int , short int ) ; 
void TTextArea_use_ ( struct TextArea * ) ; 
//Structure of class OptionPane
typedef struct OptionPane { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct OptionPane * ) ; 
	void ( * finalize_ ) ( struct OptionPane * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct OptionPane * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct OptionPane * ) ; 
	void ( * paint_ ) ( struct OptionPane * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct OptionPane * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct OptionPane * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct OptionPane * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct OptionPane * , BOOL ) ; 
	void ( * use_ ) ( struct OptionPane * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct OptionPane * , short int , short int ) ; 
	void ( * center_ ) ( struct OptionPane * ) ; 
	struct Component * ( * toFront_Component ) ( struct OptionPane * , struct Component * ) ; 
	void ( * clean_ ) ( struct OptionPane * ) ; 
	void ( * checkMnemonic_char ) ( struct OptionPane * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct OptionPane * ) ; 
	void ( * repaintChildren_ ) ( struct OptionPane * ) ; 
	void ( * paintForeground_ ) ( struct OptionPane * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct OptionPane * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct OptionPane * , struct Component * ) ; 
	void ( * remove_Component ) ( struct OptionPane * , struct Component * ) ; 
	//Fields from class Frame
/** Is this frame movable ?*/
	BOOL movable ; 
/** Is this frame modal ?  Should be only read.*/
	BOOL modal ; 
/** The default close operation for this frame.*/
	short int defaultCloseOperation ; 
/** Is the close button visible ?  Should be only read.*/
	BOOL closeButtonVisible ; 
/** Is the minimize button visible ?  Should be only read.*/
	BOOL minimizeButtonVisible ; 
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class Frame
	BOOL ( * isCursorOverCloseButton_short_int_short_int ) ( struct OptionPane * , short int , short int ) ; 
	BOOL ( * isCursorOverMinimizeButton_short_int_short_int ) ( struct OptionPane * , short int , short int ) ; 
	BOOL ( * isCursorOverTitleBar_short_int_short_int ) ( struct OptionPane * , short int , short int ) ; 
	void ( * onClose_ ) ( struct OptionPane * ) ; 
	void ( * onMinimize_ ) ( struct OptionPane * ) ; 
	void ( * onDrag_ ) ( struct OptionPane * ) ; 
	void ( * dispose_ ) ( struct OptionPane * ) ; 
	void ( * setCaption_String ) ( struct OptionPane * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct OptionPane * , short int ) ; 
	//Fields from class OptionPane

/** The selected option of this option pane.*/
	short int option ; 
/** The input value of this option pane.*/
	struct String * value ; 
/** The "ok" button.*/
	struct Button * btnOk ; 
/** The "yes" button.*/
	struct Button * btnYes ; 
/** The "no" button.*/
	struct Button * btnNo ; 
/** The "cancel" button.*/
	struct Button * btnCancel ; 
/** The textfield used in input dialogs.*/
	struct TextField * text ; 
/** The label used in message and confirm dialogs.*/
	struct Label * message ; 
	//Methods from class OptionPane
} TOptionPane ; 
struct OptionPane * TOptionPane0 ( ) ; 
struct OptionPane * OptionPane ; //Generic OptionPane object prototype
/** The dialog used when calling one of the "show" methods.*/
struct OptionPane *  OptionPane_dialog ; 
/** Default return value. */
#define OptionPane_DEFAULT_OPTION - 1 
/** Return value from class method if YES is chosen. */
#define OptionPane_YES_OPTION 0 
/** Return value from class method if NO is chosen. */
#define OptionPane_NO_OPTION 1 
/** Return value from class method if CANCEL is chosen. */
#define OptionPane_CANCEL_OPTION 2 
/** Return value form class method if OK is chosen. */
#define OptionPane_OK_OPTION 0 
struct OptionPane * TOptionPane_ ( ) ; 
void OptionPane__ ( struct OptionPane * ) ; 
void OptionPane_finally_ ( ) ; 
void OptionPane_prepare_ ( ) ; 
struct String * OptionPane_showInputDialog_String ( struct String * ) ; 
struct String * OptionPane_showInputDialog_Container_String_String ( struct Container * , struct String * , struct String * ) ; 
void TOptionPane_eventTriggered_Object ( struct OptionPane * , struct Object * ) ; 
//Interface Captioned
//Structure of class Container
typedef struct Container { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Container * ) ; 
	void ( * finalize_ ) ( struct Container * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct Container * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct Container * ) ; 
	void ( * paint_ ) ( struct Container * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct Container * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct Container * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct Container * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct Container * , BOOL ) ; 
	void ( * use_ ) ( struct Container * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct Container * , short int , short int ) ; 
	void ( * center_ ) ( struct Container * ) ; 
	struct Component * ( * toFront_Component ) ( struct Container * , struct Component * ) ; 
	void ( * clean_ ) ( struct Container * ) ; 
	void ( * checkMnemonic_char ) ( struct Container * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct Container * ) ; 
	void ( * repaintChildren_ ) ( struct Container * ) ; 
	void ( * paintForeground_ ) ( struct Container * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct Container * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct Container * , struct Component * ) ; 
	void ( * remove_Component ) ( struct Container * , struct Component * ) ; 
} TContainer ; 
struct Container * TContainer0 ( ) ; 
struct Container * Container ; //Generic Container object prototype
struct Container * TContainer_ ( ) ; 
void Container__ ( struct Container * ) ; 
void TContainer_onPaint_ ( struct Container * ) ; 
void TContainer_onRefresh_ ( struct Container * ) ; 
void TContainer_repaintChildren_ ( struct Container * ) ; 
void TContainer_paintForeground_ ( struct Container * ) ; 
void TContainer_paintChildren_SCR_RECT_p ( struct Container * , SCR_RECT * ) ; 
void TContainer_use_ ( struct Container * ) ; 
void TContainer_checkMnemonic_char ( struct Container * , char ) ; 
void TContainer_add_Component ( struct Container * , struct Component * ) ; 
void TContainer_remove_Component ( struct Container * , struct Component * ) ; 
struct Component * TContainer_toFront_Component ( struct Container * , struct Component * ) ; 
void TContainer_clean_ ( struct Container * ) ; 
//Structure of class MenuBar
typedef struct MenuBar { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct MenuBar * ) ; 
	void ( * finalize_ ) ( struct MenuBar * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct MenuBar * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct MenuBar * ) ; 
	void ( * paint_ ) ( struct MenuBar * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct MenuBar * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct MenuBar * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct MenuBar * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct MenuBar * , BOOL ) ; 
	void ( * use_ ) ( struct MenuBar * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct MenuBar * , short int , short int ) ; 
	void ( * center_ ) ( struct MenuBar * ) ; 
	struct Component * ( * toFront_Component ) ( struct MenuBar * , struct Component * ) ; 
	void ( * clean_ ) ( struct MenuBar * ) ; 
	void ( * checkMnemonic_char ) ( struct MenuBar * , char ) ; 
	//Fields from class Container
/** The first component in this Container.*/
	struct Component * child ; 
/** The last component in this Container.*/
	struct Component * tail ; 
	//Methods from class Container
	void ( * onRefresh_ ) ( struct MenuBar * ) ; 
	void ( * repaintChildren_ ) ( struct MenuBar * ) ; 
	void ( * paintForeground_ ) ( struct MenuBar * ) ; 
	void ( * paintChildren_SCR_RECT_p ) ( struct MenuBar * , SCR_RECT * ) ; 
	void ( * add_Component ) ( struct MenuBar * , struct Component * ) ; 
	void ( * remove_Component ) ( struct MenuBar * , struct Component * ) ; 
	//Fields from class MenuBar
	//Methods from class MenuBar
	void ( * add_Menu ) ( struct MenuBar * , struct Menu * ) ; 
	void ( * update_ ) ( struct MenuBar * ) ; 
} TMenuBar ; 
struct MenuBar * TMenuBar0 ( ) ; 
struct MenuBar * MenuBar ; //Generic MenuBar object prototype
struct MenuBar * TMenuBar_ ( ) ; 
void MenuBar__ ( struct MenuBar * ) ; 
void TMenuBar_paintForeground_ ( struct MenuBar * ) ; 
void TMenuBar_add_Menu ( struct MenuBar * , struct Menu * ) ; 
void TMenuBar_update_ ( struct MenuBar * ) ; 
//Structure of class Component
typedef struct Component { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Component * ) ; 
	void ( * finalize_ ) ( struct Component * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct Component * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct Component * ) ; 
	void ( * paint_ ) ( struct Component * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct Component * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct Component * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct Component * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct Component * , BOOL ) ; 
	void ( * use_ ) ( struct Component * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct Component * , short int , short int ) ; 
	void ( * center_ ) ( struct Component * ) ; 
	struct Component * ( * toFront_Component ) ( struct Component * , struct Component * ) ; 
	void ( * clean_ ) ( struct Component * ) ; 
	void ( * checkMnemonic_char ) ( struct Component * , char ) ; 
} TComponent ; 
struct Component * TComponent0 ( ) ; 
struct Component * Component ; //Generic Component object prototype
struct Component * TComponent_ ( ) ; 
void Component__ ( struct Component * ) ; 
void TComponent_finalize_ ( struct Component * ) ; 
void TComponent_eventTriggered_Object ( struct Component * , struct Object * ) ; 
void TComponent_onPaint_ ( struct Component * ) ; 
void TComponent_paint_ ( struct Component * ) ; 
void TComponent_setBounds_short_int_short_int_short_int_short_int ( struct Component * , short int , short int , short int , short int ) ; 
void TComponent_setY_short_int ( struct Component * , short int ) ; 
void TComponent_move_short_int_short_int ( struct Component * , short int , short int ) ; 
void TComponent_setVisible_BOOL ( struct Component * , BOOL ) ; 
void TComponent_use_ ( struct Component * ) ; 
BOOL TComponent_isCursorOver_short_int_short_int ( struct Component * , short int , short int ) ; 
void TComponent_center_ ( struct Component * ) ; 
struct Component * TComponent_toFront_Component ( struct Component * , struct Component * ) ; 
void TComponent_clean_ ( struct Component * ) ; 
void TComponent_checkMnemonic_char ( struct Component * , char ) ; 
//Structure of class CaptionedComponent
typedef struct CaptionedComponent { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct CaptionedComponent * ) ; 
	void ( * finalize_ ) ( struct CaptionedComponent * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct CaptionedComponent * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct CaptionedComponent * ) ; 
	void ( * paint_ ) ( struct CaptionedComponent * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct CaptionedComponent * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct CaptionedComponent * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct CaptionedComponent * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct CaptionedComponent * , BOOL ) ; 
	void ( * use_ ) ( struct CaptionedComponent * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct CaptionedComponent * , short int , short int ) ; 
	void ( * center_ ) ( struct CaptionedComponent * ) ; 
	struct Component * ( * toFront_Component ) ( struct CaptionedComponent * , struct Component * ) ; 
	void ( * clean_ ) ( struct CaptionedComponent * ) ; 
	void ( * checkMnemonic_char ) ( struct CaptionedComponent * , char ) ; 
	//Fields from class CaptionedComponent
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class CaptionedComponent
	void ( * setCaption_String ) ( struct CaptionedComponent * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct CaptionedComponent * , short int ) ; 
} TCaptionedComponent ; 
struct CaptionedComponent * TCaptionedComponent0 ( ) ; 
struct CaptionedComponent * CaptionedComponent ; //Generic CaptionedComponent object prototype
struct CaptionedComponent * TCaptionedComponent_String ( struct String * ) ; 
void CaptionedComponent__String ( struct CaptionedComponent * , struct String * ) ; 
void TCaptionedComponent_finalize_ ( struct CaptionedComponent * ) ; 
void TCaptionedComponent_setCaption_String ( struct CaptionedComponent * , struct String * ) ; 
void TCaptionedComponent_setFont_short_int ( struct CaptionedComponent * , short int ) ; 
//Interface Styled
//Structure of class Label
typedef struct Label { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Label * ) ; 
	void ( * finalize_ ) ( struct Label * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct Label * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct Label * ) ; 
	void ( * paint_ ) ( struct Label * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct Label * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct Label * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct Label * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct Label * , BOOL ) ; 
	void ( * use_ ) ( struct Label * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct Label * , short int , short int ) ; 
	void ( * center_ ) ( struct Label * ) ; 
	struct Component * ( * toFront_Component ) ( struct Label * , struct Component * ) ; 
	void ( * clean_ ) ( struct Label * ) ; 
	void ( * checkMnemonic_char ) ( struct Label * , char ) ; 
	//Fields from class CaptionedComponent
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class CaptionedComponent
	void ( * setCaption_String ) ( struct Label * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct Label * , short int ) ; 
	//Fields from class Label
/** The background color for this component.  Should be only read.*/
	short int bgColor ; 
/** The foreground color for this component.  Should be only read.*/
	short int fgColor ; 
	//Methods from class Label
} TLabel ; 
struct Label * TLabel0 ( ) ; 
struct Label * Label ; //Generic Label object prototype
struct Label * TLabel_ ( ) ; 
void Label__ ( struct Label * ) ; 
struct Label * TLabel_String ( struct String * ) ; 
void Label__String ( struct Label * , struct String * ) ; 
void TLabel_paint_ ( struct Label * ) ; 
//Structure of class TextField
typedef struct TextField { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct TextField * ) ; 
	void ( * finalize_ ) ( struct TextField * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct TextField * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct TextField * ) ; 
	void ( * paint_ ) ( struct TextField * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct TextField * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct TextField * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct TextField * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct TextField * , BOOL ) ; 
	void ( * use_ ) ( struct TextField * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct TextField * , short int , short int ) ; 
	void ( * center_ ) ( struct TextField * ) ; 
	struct Component * ( * toFront_Component ) ( struct TextField * , struct Component * ) ; 
	void ( * clean_ ) ( struct TextField * ) ; 
	void ( * checkMnemonic_char ) ( struct TextField * , char ) ; 
	//Fields from class CaptionedComponent
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class CaptionedComponent
	void ( * setCaption_String ) ( struct TextField * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct TextField * , short int ) ; 
	//Fields from class TextField
/** The number of character this TextField should accept. Should be > 0.*/
	short int maxLength ; 
/** The input type of this TextField*/
	short int inputType ; 
/** The mask for this TextField. '\0' (default) to disable. Should be only read.*/
	char mask ; 
	//Methods from class TextField
	BOOL ( * checkInput_short_int_char_p_short_int ) ( struct TextField * , short int , char * , short int ) ; 
} TTextField ; 
struct TextField * TTextField0 ( ) ; 
struct TextField * TextField ; //Generic TextField object prototype
/** The TextField accepts any character.*/
#define TextField_NO_INPUT_TYPE 0 
/** The TextField only accepts integers.*/
#define TextField_INT_INPUT_TYPE 1 
/** The TextField only accepts integers and floats.*/
#define TextField_FLOAT_INPUT_TYPE 2 
/** The TextField only accepts characters.*/
#define TextField_CHAR_INPUT_TYPE 3 
struct TextField * TTextField_ ( ) ; 
void TextField__ ( struct TextField * ) ; 
struct TextField * TTextField_String ( struct String * ) ; 
void TextField__String ( struct TextField * , struct String * ) ; 
void TTextField_paint_ ( struct TextField * ) ; 
void TTextField_use_ ( struct TextField * ) ; 
BOOL TTextField_checkInput_short_int_char_p_short_int ( struct TextField * , short int , char * , short int ) ; 
//Structure of class Menu
typedef struct Menu { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Menu * ) ; 
	void ( * finalize_ ) ( struct Menu * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct Menu * , struct Object * ) ; 
	//Fields from class Component
/** The image of the component to be displayed.*/
	BITMAP * img ; 
/** Is the component need to be repainted ?*/
	BOOL repaint ; 
/** The next component in the container of this Component.*/
	struct Component * next ; 
/** The previous component in the container of this Component.*/
	struct Component * prev ; 
/** The parent Container of this Component.*/
	struct Container * parent ; 
/** The height of this Component. Should be only read.*/
	short int height ; 
/** The width of this Component. Should be only read.*/
	short int width ; 
/** The horizontal coordinate of this Component. Should be only read.*/
	short int x ; 
/** The vertical coordinate of this Component. Should be only read.*/
	short int y ; 
/** Is the Component visible ? Should be only read.*/
	BOOL visible ; 
/** Is the Component enabled ? Should be only read.*/
	BOOL enabled ; 
/** The mnemonic associated with this component.*/
	char mnemonic ; 
/** The event listener for this component.*/
	struct EventListener * listen ; 
	//Methods from class Component
	void ( * onPaint_ ) ( struct Menu * ) ; 
	void ( * paint_ ) ( struct Menu * ) ; 
	void ( * setBounds_short_int_short_int_short_int_short_int ) ( struct Menu * , short int , short int , short int , short int ) ; 
	void ( * setY_short_int ) ( struct Menu * , short int ) ; 
	void ( * move_short_int_short_int ) ( struct Menu * , short int , short int ) ; 
	void ( * setVisible_BOOL ) ( struct Menu * , BOOL ) ; 
	void ( * use_ ) ( struct Menu * ) ; 
	BOOL ( * isCursorOver_short_int_short_int ) ( struct Menu * , short int , short int ) ; 
	void ( * center_ ) ( struct Menu * ) ; 
	struct Component * ( * toFront_Component ) ( struct Menu * , struct Component * ) ; 
	void ( * clean_ ) ( struct Menu * ) ; 
	void ( * checkMnemonic_char ) ( struct Menu * , char ) ; 
	//Fields from class CaptionedComponent
/** The font for this component.  Should be only read.*/
	short int font ; 
/** The caption of the component.*/
	struct String * caption ; 
	//Methods from class CaptionedComponent
	void ( * setCaption_String ) ( struct Menu * , struct String * ) ; 
	void ( * setFont_short_int ) ( struct Menu * , short int ) ; 
	//Fields from class Label
/** The background color for this component.  Should be only read.*/
	short int bgColor ; 
/** The foreground color for this component.  Should be only read.*/
	short int fgColor ; 
	//Methods from class Label
	//Fields from class Menu
/** A vector containing the items of this Menu.*/
	struct Vector * items ; 
	//Methods from class Menu
	void ( * add_MenuItem ) ( struct Menu * , struct MenuItem * ) ; 
} TMenu ; 
struct Menu * TMenu0 ( ) ; 
struct Menu * Menu ; //Generic Menu object prototype
void TMenu_finalize_ ( struct Menu * ) ; 
struct Menu * TMenu_String ( struct String * ) ; 
void Menu__String ( struct Menu * , struct String * ) ; 
void TMenu_paint_ ( struct Menu * ) ; 
void TMenu_add_MenuItem ( struct Menu * , struct MenuItem * ) ; 
void TMenu_onPaint_ ( struct Menu * ) ; 
void TMenu_setVisible_BOOL ( struct Menu * , BOOL ) ; 
void TMenu_use_ ( struct Menu * ) ; 
//Structure of class Style
typedef struct Style { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Style * ) ; 
	void ( * finalize_ ) ( struct Style * ) ; 
	//Fields from class Style
	//Methods from class Style
} TStyle ; 
/** Draw usign the normal style.*/
#define Style_NORMAL_STYLE B_NORMAL 
/** Draw usign the raised style.*/
#define Style_RAISED_STYLE 0x100 
//Interface Colored
//Structure of class MenuItem
typedef struct MenuItem { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct MenuItem * ) ; 
	void ( * finalize_ ) ( struct MenuItem * ) ; 
	//Fields from class EventListener
	//Methods from class EventListener
	void ( * eventTriggered_Object ) ( struct MenuItem * , struct Object * ) ; 
	//Fields from class MenuItem
/** The caption of the MenuItem. Should be only read.*/
	struct String * caption ; 
/** The event listener for this MenuItem.*/
	struct EventListener * listen ; 

/** The mnemonic associated with this MenuItem.*/
	char mnemonic ; 
	//Methods from class MenuItem
	void ( * setCaption_String ) ( struct MenuItem * , struct String * ) ; 
} TMenuItem ; 
struct MenuItem * TMenuItem0 ( ) ; 
struct MenuItem * MenuItem ; //Generic MenuItem object prototype
struct MenuItem * TMenuItem_String ( struct String * ) ; 
void MenuItem__String ( struct MenuItem * , struct String * ) ; 
void TMenuItem_setCaption_String ( struct MenuItem * , struct String * ) ; 
void TMenuItem_finalize_ ( struct MenuItem * ) ; 
//Structure of class Color
typedef struct Color { 
	char * class ; 
	short int class_id ; 
	struct Object * super ; 
	//Fields from class Object
	//Methods from class Object
	struct String * ( * toString_ ) ( struct Color * ) ; 
	void ( * finalize_ ) ( struct Color * ) ; 
	//Fields from class Color
	//Methods from class Color
} TColor ; 
/** Draw in black.*/
#define Color_BLACK_COLOR A_NORMAL 
/** Draw in white.*/
#define Color_WHITE_COLOR A_REVERSE 
